* J. MAURICE jsm.maurice@wanadoo.fr  www.atoutfox.org
* (et aussi www.aedtf.org !!)
* librairie de classes pour l'automation d'OpenOffice 2.0 et 3.0
*  partir de VFP (Visual FoxPro). Version du jme 20/10/2008
* Ces classes sont issues de nombreuses contributions en particulier
* celles de Ted ROCHE. 
* Le livre Programmation OpenOffice.org 2 macros et API aux ditions
* Eyrolles auteurs : Bernard MARCILLY et Laurent Godard m'a t d'un
* trs grand secours.
* un remerciement spcial 
*   Bernard MARCILLY, un des auteurs du livre qui m'a dfrich le terrain
*   Cesar CHALOM pour ses liens
*   Olivier HAMOU
*   ...
* les sites suivants sont aussi dignes d'intret :
*  http://www.oooforum.org/forum/viewtopic.phtml?p=28389#28389


*
* dans tout ce qui suit OO veut dire OpenOffice

* Ce document comprend d'abord quelques dfinitions, puis une srie de petites
* classes correspondant plus  une structure C qu' une vraie classe (mais elles
* peuvent avoir quelques mthodes) et enfin les classes utilisables par le programmeur.
* Ces classes respectent un peu la hierarchie d'OO : une classe de base contient
* les proprits et les mthodes communes  chaque document OO (c'est vfp_oo); elle
* est sous classe en vfp_oo_writer pour manipuler le traitement de texte; puis
* en vfp_oo_calc pour manipuler le tableur, ...

* Liste des classes et de leurs mthodes
** Classe: OO_POLICE   base sur Custom
**      242 .init
**      247 .faire
**      280 .a_nom_assign
**      294 .a_taille_assign
**      305 .a_gras_assign
**      319 .a_italique_assign
**      330 .a_souligne_assign
**
** Classe: OO_PARAGRAPHE   base sur Custom
**      363 .init
**      368 .alignement
**      386 .faire
**      425 .a_marge_gauche_assign
**      439 .a_marge_droite_assign
**      450 .a_retrait_ligne1_assign
**
** Classe: PARAMETRES_IMPRIMANTE   base sur Custom
**
** Classe: PARAMETRES_PAGE   base sur Custom
**      486 .init
**      492 .faire
**
** Classe: PARAMETRES_IMPRESSION   base sur custom
**
** Classe: ENTETE_PIED_DE_PAGE   base sur custom
**      592 .init
**      659 .destroy
**      663 .faire
**
** Classe: VFP_OO   base sur custom
**      723 .init
**      839 .destroy
**      854 .nouveau_document
**      888 .ouvrir_document
**      928 .enregistrer_document
**      954 .enregistrer_copie_document
**      981 .fermer_document
**     1005 .imprimer_document
**     1060 .informations_document
**     1084 .OOoOpenURL
**     1114 .OOoPropertyValue
**     1134 .OOoCreateStruct
**     1159 .OOoConvertToURL
**
** Classe: VFP_OO_WRITER   base sur vfp_oo
**     1189 .init
**     1197 .destroy
**     1209 .nouveau_document_texte
**     1248 .ouvrir_document_texte
**     1300 .objets_doc
**     1314 .enregistrer_copie_document
**     1339 .informations_document
**     1353 .debut_texte
**     1357 .ajouter_texte
**     1361 .nouveau_paragraphe
**     1367 .retour_ligne
**     1372 .appliquer_police
**     1379 .police
**     1396 .creer_entete
**     1422 .parametrage_entete
**     1446 .textes_entete
**
** Classe: OO_FEUILLE   base sur Custom
**     1494 .init
**     1515 .destroy
**     1518 .caracteristiques
**     1531 .max_ligne_colonne
**
** Classe: VFP_OO_CALC   base sur vfp_oo
**     1645 .init
**     1654 .destroy
**     1666 .nouveau_tableur
**     1687 .ouvrir_tableur
**     1724 .maj_infos_tableur
**     1766 .enregistrer_copie_document
**     1791 .informations_document
**     1805 .selection_feuille
**     1864 .ajouter_feuille
**     1916 .cellule_coord_alpha_vers_num
**     1943 .cellule_coord_num_vers_alpha
**     1977 .texte_dans_cellule
**     1990 .valeur_dans_cellule
**     2003 .formule_dans_cellule
**     2016 .date_dans_cellule
**     2050 .lire_une_cellule

*OO_automation/sdk/docs/common/ref/com/sun/star/text/ControlCharacter.html
#DEFINE PARAGRAPH_BREAK   0 && nouveau paragraphe
#DEFINE LINE_BREAK        1 && nouvelle ligne dans un paragraphe
#DEFINE HARD_HYPHEN       2 && tiret inscable
#DEFINE SOFT_HYPHEN       3 && tiret conditionnel
#DEFINE HARD_SPACE        4 && espace inscable
#DEFINE APPEND_PARAGRAPH  5 && ajoute un nouveau paragraphe

#DEFINE COLOR_WHITE        16777215
#DEFINE COLOR_BLACK               0

* OO_automation/sdk/idl/com/sun/star/awt/FontWeight.idl  : graisse des caractres
#DEFINE GRAISSE_DONTKNOW    0.000000    && graisse par dfaut
#DEFINE GRAISSE_THIN       50.000000    && caractres fin (moiti de la graisse normale)
#DEFINE GRAISSE_ULTRALIGHT 60.000000    && caractres ultra fins (60% de la graisse normale) 
#DEFINE GRAISSE_LIGHT      75.000000    && caractres fins (3/4 de la graisse normale) 
#DEFINE GRAISSE_SEMILIGHT  90.000000    && 90% de la graisse normale 
#DEFINE GRAISSE_NORMAL    100.000000    && graisse normale 
#DEFINE GRAISSE_SEMIBOLD  110.000000    && demi gras (110% de la graisse normale)
#DEFINE GRAISSE_BOLD      150.000000    && gras 
#DEFINE GRAISSE_ULTRABOLD 175.000000    && trs gras 
#DEFINE GRAISSE_BLACK     200.000000    && ultra gras

* OO_automation/sdk/idl/com/sun/star/awt/FontUnderline.idl  : soulignement
#DEFINE SOULIGN_NONE            0 && pas de soulignement
#DEFINE SOULIGN_SINGLE          1 && ligne simple
#DEFINE SOULIGN_DOUBLE          2 && ligne double
#DEFINE SOULIGN_DOTTED          3 && pointill
#DEFINE SOULIGN_DONTKNOW        4 && inconnu (??!!??)
#DEFINE SOULIGN_DASH            5 && tirets
#DEFINE SOULIGN_LONGDASH        6 && tirets longs
#DEFINE SOULIGN_DASHDOT         7 && tiret point
#DEFINE SOULIGN_DASHDOTDOT      8 && tiret point point
#DEFINE SOULIGN_SMALLWAVE       9 && petite vague
#DEFINE SOULIGN_WAVE           10 && vague
#DEFINE SOULIGN_DOUBLEWAVE     11 && double vague
#DEFINE SOULIGN_BOLD           12 && ligne grasse
#DEFINE SOULIGN_BOLDDOTTED     13 && points gras
#DEFINE SOULIGN_BOLDDASH       14 && tirets gras
#DEFINE SOULIGN_BOLDLONGDASH   15 && long tirets gras
#DEFINE SOULIGN_BOLDDASHDOT    16 && tiret point gras
#DEFINE SOULIGN_BOLDDASHDOTDOT 17 && tiret point point en gras
#DEFINE SOULIGN_BOLDWAVE       18 && vague grasse

* OO_automation/sdk/idl/com/sun/star/awt/FontWidth.idl
#DEFINE LARGEUR_DONTKNOW         0.000000  && largeur inconnue (par dfaut ?)
#DEFINE LARGEUR_ULTRACONDENSED  50.000000  && condens (50%)
#DEFINE LARGEUR_EXTRACONDENSED  60.000000  && condens (60%)
#DEFINE LARGEUR_CONDENSED       75.000000  && condens (75%)
#DEFINE LARGEUR_SEMICONDENSED   90.000000  && semi-condens (90%)
#DEFINE LARGEUR_NORMAL         100.000000  && normal
#DEFINE LARGEUR_SEMIEXPANDED   110.000000  && semi-expans (110%)
#DEFINE LARGEUR_EXPANDED       150.000000  && expans (150%)
#DEFINE LARGEUR_EXTRAEXPANDED  175.000000  && extraexpans (175%)
#DEFINE LARGEUR_ULTRAEXPANDED  200.000000  && ultra-expans (200%)
 
* OO_automation/sdk/idl/com/sun/star/awt/Fontslant.idl
*!*  published enum FontSlant ATTENTION numration et non constantes
*!*  { 
*!*    /** specifies a font without slant.   */
*!*    NONE, 
*!*    /** specifies an oblique font (slant not designed into the font).   */
*!*    OBLIQUE, 
*!*    /** specifies an italic font (slant designed into the font).   */
*!*    ITALIC, 
*!*    /** specifies a font with an unknown slant.  */
*!*    DONTKNOW, 
*!*    /** specifies a reverse oblique font (slant not designed into the font).  */
*!*    REVERSE_OBLIQUE, 
*!*    /** specifies a reverse italic font (slant designed into the font).   */
*!*    REVERSE_ITALIC 
#DEFINE ITALIC_DROIT            0 && pas d'italique
#DEFINE ITALIC_OBLIQUE          1 && italique si la police ne l'accepte pas (non utilis ici)
#DEFINE ITALIC_ITALIC           2 && italique ( condition que la police l'accepte)
#DEFINE ITALIC_INCONNU          3 && comme son nom l'indique !! (non utilis ici)
#DEFINE ITALIC_OBLIQUE_INVERSE  4 && italique inverse (penche  gauche) si la police
                                  && ne l'accepte pas (non utilis ici)
#DEFINE ITALIC_INVERSE          5 && italique inverse (penche  gauche si la police
                                  && l'accepte (non utilis ici

* OO_automation/sdk/idl/com/sun/star/style/ParagraphAdjust.idl
*!*  published enum ParagraphAdjust ATTENTION numration et non constantes
*!*    // value com::sun::star::style::ParagraphAdjust::LEFT
*!*    /** adjusted to the left border
*!*    LEFT, 
*!*    // value com::sun::star::style::ParagraphAdjust::RIGHT
*!*    /** adjusted to the right border
*!*    RIGHT, 
*!*    // value com::sun::star::style::ParagraphAdjust::BLOCK
*!*    /** adjusted to both borders / stretched, except for last line
*!*    BLOCK, 
*!*    // value com::sun::star::style::ParagraphAdjust::CENTER
*!*    /** adjusted to the center
*!*    CENTER, 
*!*    // value com::sun::star::style::ParagraphAdjust::STRETCH
*!*    /** adjusted to both borders / stretched, including last line
*!*    STRETCH 
*!*  }
#DEFINE ALIGNEMENT_GAUCHE        0  && paragraphe cadr  gauche
#DEFINE ALIGNEMENT_DROIT         1  && paragraphe cadr  droite
#DEFINE ALIGNEMENT_JUSTIFIE_BEAU 2  && paragraphe justifi sauf la dernire
                                    && ligne qui reste  gauche
#DEFINE ALIGNEMENT_CENTRE        3  && paragraphe centr
#DEFINE ALIGNEMENT_JUSTIFIE      4  && paragraphe justifi y compris la dernire ligne


#DEFINE avec_ww .T.   && si cette constante est dfinie, on affiche des messages
  * d'erreur avec WAIT WINDOW. Si vous mettez la ligne en commentaire et que vous
  * recompilez, aucun message n'est affich en cas d'erreur

* ATTENTION : NE METTRE AUCUN CODE EXECUTABLE APRES UN DEFINE CLASS

DEFINE CLASS oo_police AS Custom && jme 04/11/2007
  * paramtres d'une police de caractres
  * je suis oblig de renommer les constantes car dans OO on peut avoir deux constantes
  * de mme nom dans deux fichiers de dclaration diffrents mais pas dans VFP
  * notes  propos des proprits a_nom, a_taille, a_gras, a_italique et a_souligne (dans
  * lesquelles le a_ veut dire 'automatique' : il y a une mthode assign sur chacune
  * de ces proprits et donc, si on a un seul paramtre  modifier, la simple mise  jour
  * de la proprit va bien tre reporte sur le texte. Pour les autres proprits, il 
  * faut mettre  jour les proprits puis lancer la mthode faire().
  
  nom = "Courier New"  && cette police a des caractres de taille fixe; il est donc
  *  trs facile de faire des documents avec des colonnes (facture, ...) alors que si
  *  on utilise une police proportionnelle cela devient un cauchemar.
  taille = 12
  gras = .F.
  italique = .F.
  souligne = .F.
  couleur_texte = color_black
  couleur_fond =  color_white
  * une autre possibilit pour paramtrer la police est d'utiliser les proprits
  * a_nom, a_taille, a_gras, a_italique, a_souligne ci-dessous. Sur chacune de
  * ces proprits il y a une mthode _assign qui lance la mthode This.faire; donc
  * lorsqu'on a beaucoup de paramtres  changer, on peut mettre  jour les
  * proprits nom, taille, ... puis lancer la mthode This.faire(); mais si
  * on ne veut changer qu'une seule valeur, il est plus simple de faire une
  * simple assignation sur les proprits a_nom, ...
  a_nom = "Courier New"
  a_taille = 12
  a_gras = .F.
  a_italique = .F.
  a_souligne = .F.
  curseur_ecriture = NULL   && pointeur sur le curseur d'criture. 
  * c'est sur ce curseur que vont tre appliqu la police et ses caractristiques.
    
  * il n'y a pas de mthode DESTROY dans cette classe
  
  PROCEDURE init && jme 26/11/2007
    LPARAMETERS pocurseur
    This.curseur_ecriture = m.pocurseur
  ENDPROC
  
  PROCEDURE faire( )
    * This.curseur_ecriture : curseur d'criture sur lequel on doit paramtrer
    * la police. On commence par mettre  jour les proprits de cette classe puis
    * on appelle cette mthode pour les appliquer au curseur point par
    * This.curseur_ecriture.
    * pour l'instant, je ne sais pas vrifier si l'objet pass est
    * correct. S'il y a un problme, on ne fait rien (sauf faire
    * un wait window si la compilation se fait avec avec_ww = .T.
    
    IF ISNULL(This.curseur_ecriture)
      #IFDEF avec_ww
      WAIT WINDOW "paramtrage de la police OO impossible:"+ CHR(13)+ ;
        "curseur d'criture NULL" NOWAIT
      #ENDIF
    ELSE
      TRY
        WITH This.curseur_ecriture
          .CharFontName = This.nom
          .CharHeight = This.taille
          .CharColor = This.couleur_texte
          .CharBackColor = This.couleur_fond
          .CharWeight = IIF( This.gras, GRAISSE_BOLD, GRAISSE_NORMAL)
          .CharPosture = IIF( This.italique, ITALIC_ITALIC, ITALIC_DROIT)
          .CharUnderline = IIF( This.souligne, SOULIGN_SINGLE, SOULIGN_NONE)
        ENDWITH  && This.curseur_ecriture
      CATCH
        #IFDEF avec_ww
        WAIT WINDOW "problme lors du paramtrage de la police OO" NOWAIT
        #ENDIF
      ENDTRY
    ENDIF && ISNULL(This.curseur_ecriture)
  ENDPROC && faire
  
  HIDDEN PROCEDURE a_nom_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_nom
    * une mthode HIDDEN n'est pas accessible par les heritiers de cette classe ni
    * du public (elle n'est seulement accessible que de l'intrieur de la classe
    * o elle est dfinie)
    LPARAMETERS pcnouval
    
    IF This.nom <> m.pcnouval
      STORE m.pcnouval TO This.a_nom, This.nom
      This.faire()
    ENDIF
  ENDPROC && procedure a_nom_assign
  
  HIDDEN PROCEDURE a_taille_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_taille
    LPARAMETERS pnnouval
    
    IF This.taille <> m.pnnouval
      STORE m.pnnouval TO This.a_taille, This.taille
      This.faire()
    ENDIF
  ENDPROC && procedure a_taille_assign
  
  HIDDEN PROCEDURE a_gras_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_gras
    * une mthode HIDDEN n'est pas accessible par les heritiers de cette classe ni
    * du public (elle n'est seulement accessible que de l'intrieur de la classe
    * o elle est dfinie)
    LPARAMETERS plnouval
    
    IF This.gras <> m.plnouval
      STORE m.plnouval TO This.gras, This.a_gras
      This.faire()
    ENDIF
  ENDPROC && procedure a_gras_assign
  
  HIDDEN PROCEDURE a_italique_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_italique
    LPARAMETERS plnouval
    
    IF This.italique <> m.plnouval
      STORE m.plnouval TO This.italique, This.a_italique
      This.faire()
    ENDIF
  ENDPROC && procedure a_italique_assign
  
  HIDDEN PROCEDURE a_souligne_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_souligne
    * une mthode HIDDEN n'est pas accessible par les heritiers de cette classe ni
    * du public (elle n'est seulement accessible que de l'intrieur de la classe
    * o elle est dfinie)
    LPARAMETERS plnouval
    
    IF This.souligne <> m.plnouval
      STORE m.plnouval TO This.souligne, This.a_souligne
      This.faire()
    ENDIF
  ENDPROC && procedure a_souligne_assign
  
ENDDEFINE && oo_police

DEFINE CLASS oo_paragraphe AS Custom && jme 04/11/2007
  * paramtres d'un paragraphe. Toutes les valeurs sont en 1/100mm
  * (centime de millimtre)

  marge_gauche = 0  && 1000 = 1cm
  retrait_ligne1 = 0
  marge_droite = 0
  hauteur_avant = 0
  hauteur_apres = 0
  gdcj = ALIGNEMENT_GAUCHE  && alignement par dfaut du paragraphe
  curseur_ecriture = NULL   && pointeur sur le curseur d'criture. 
  * c'est sur ce curseur que vont tre appliqu les paramtres du paragraphe
  a_marge_gauche = 0  && il y aune mthode _assign
  a_retrait_ligne1 = 0
  a_marge_droite = 0
  
  * il n'y a pas de mthode DESTROY dans cette classe
  PROCEDURE init
    LPARAMETERS pocurseur
    This.curseur_ecriture = m.pocurseur
  ENDPROC
  
  PROCEDURE alignement( pcalign AS String)
    * NOTE test : cette mthode a le mme nom qu'une des proprits !
    IF "CENTR" $ UPPER(m.pcalign)
      This.gdcj = ALIGNEMENT_CENTRE
    ELSE
      IF "DROIT" $ UPPER(pcalign)
        This.gdcj = ALIGNEMENT_DROIT
      ELSE
        IF "JUSTI" $ UPPER(m.pcalign)
          This.gdcj = ALIGNEMENT_JUSTIFIE_BEAU
        ELSE
          This.gdcj = ALIGNEMENT_GAUCHE
        ENDIF && "JUSTI" $ UPPER(m.pcalign)
      ENDIF && "DROIT" $ UPPER(pcalign)
    ENDIF && "CENTR" $ UPPER(m.pcalign)
    This.faire()
  ENDPROC && alignement

  PROCEDURE faire( )
    * This.curseur_ecriture : curseur d'criture sur lequel on doit paramtrer
    * le paragraphe. On commence par mettre  jour les proprits de cette classe puis
    * on appelle cette mthode pour les appliquer au curseur point par
    * This.curseur_ecriture.
    * pour l'instant, je ne sais pas vrifier si l'objet pass est
    * correct. S'il y a un problme, on ne fait rien (sauf faire
    * un wait window si la compilation se fait avec avec_ww = .T.
    
    IF ISNULL(This.curseur_ecriture)
      #IFDEF avec_ww
      WAIT WINDOW "paramtrage du paragraphe OO impossible:"+ CHR(13)+ ;
        "curseur d'criture NULL" NOWAIT
      #ENDIF
    ELSE
      TRY
        WITH This.curseur_ecriture
          .ParaLeftMargin = This.marge_gauche
          .ParaFirstLineIndent = This.retrait_ligne1
          .ParaRightMargin = This.marge_droite
          .ParaTopMargin = This.hauteur_avant
          .ParaBottomMargin = This.hauteur_apres
          .ParaAdjust = This.gdcj
          IF INLIST(This.gdcj, ALIGNEMENT_JUSTIFIE, ALIGNEMENT_JUSTIFIE_BEAU)
            IF This.gdcj = ALIGNEMENT_JUSTIFIE_BEAU
              .ParaLastLineAdjust = ALIGNEMENT_GAUCHE
            ELSE
              .ParaLastLineAdjust = ALIGNEMENT_JUSTIFIE
            ENDIF && This.alignement = ALIGNEMENT_JUSTIFIE_BEAU
          ENDIF && INLIST(This.gdcj, ALIGNEMENT_JUSTIFIE, ALIGNEMENT_JUSTIFIE_BEAU)
        ENDWITH  && This.curseur_ecriture
      CATCH
        #IFDEF avec_ww
        WAIT WINDOW "problme lors du paramtrage du paragraphe OO" NOWAIT
        #ENDIF
      ENDTRY
    ENDIF && ISNULL(This.curseur_ecriture)
  ENDPROC && faire

  HIDDEN PROCEDURE a_marge_gauche_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_marge_gauche
    * quand on a qu'une seule valeur  changer il est plus facile de
    * mettre  jour a_marge_gauche qui aura un effet immdiat que d'crire
    * deux lignes de programme
    LPARAMETERS plnouval
    
    IF This.marge_gauche <> m.plnouval
      STORE m.plnouval TO This.marge_gauche, This.a_marge_gauche
      This.faire()
    ENDIF
  ENDPROC && procedure a_marge_gauche_assign
  
  HIDDEN PROCEDURE a_marge_droite_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_marge_droite
    LPARAMETERS plnouval
    
    IF This.marge_droite <> m.plnouval
      STORE m.plnouval TO This.marge_droite, This.a_marge_droite
      This.faire()
    ENDIF
  ENDPROC && procedure a_marge_droite_assign
  
  HIDDEN PROCEDURE a_retrait_ligne1_assign
    * cette mthode est lance automatiquement (suffixe _assign) chaque fois
    * que l'on modifie la valeur de This.a_retrait_ligne1
    LPARAMETERS plnouval
    
    IF This.retrait_ligne1 <> m.plnouval
      STORE m.plnouval TO This.retrait_ligne1, This.a_retrait_ligne1
      This.faire()
    ENDIF
  ENDPROC && procedure a_retrait_ligne1_assign
  
ENDDEFINE && oo_paragraphe

DEFINE CLASS parametres_imprimante AS Custom
  marge_haute = 1
  marge_basse = 1
  marge_gauche = 1
  marge_droite = 1
  nom_imprimante = ""
  orientation = 1       && 1 portrait, 2 paysage
ENDDEFINE && parametres_imprimante AS Custom

DEFINE CLASS parametres_page AS Custom
  * dfinition des paramtres de la page
  * les valeurs sont en centimes de millimtre
  * les paramtres modifis sont ceux du style standard
  
  marge_haute = 1000
  marge_basse = 1000
  marge_gauche = 1000
  marge_droite = 1000
  orientation = 1       && 1 portrait, 2 paysage
  page = NULL           && pointeur sur le document
  sf = NULL             && pointeur sur la famille de styles
  standard = NULL       && pointeur sur le style standard
  
  PROCEDURE init
    LPARAMETERS pocurseur
    This.page = m.pocurseur
    This.faire()
  ENDPROC
  
  PROCEDURE faire( )
    * This.page : objet que l'on doit paramtrer
    * On commence par mettre  jour les proprits de cette classe puis
    * on appelle cette mthode pour les appliquer au document point par
    * This.page.
    * pour l'instant, je ne sais pas vrifier si l'objet pass est
    * correct. S'il y a un problme, on ne fait rien (sauf faire
    * un wait window si la compilation se fait avec avec_ww = .T.
    * les valeurs sont en centimes de millimtres
    
    IF ISNULL(This.page)
      #IFDEF avec_ww
      WAIT WINDOW "paramtrage de la page OO impossible:"+ CHR(13)+ ;
        "document NULL" NOWAIT
      #ENDIF
    ELSE
      TRY
        This.sf = This.page.StyleFamilies.getByName("PageStyles")
        This.standard = This.sf.getByName("Standard")
        IF ISNULL( This.standard)
          #IFDEF avec_ww
          WAIT WINDOW "paramtrage de la page OO impossible:"+ CHR(13)+ ;
            "style standard NULL" NOWAIT
          #ENDIF
        ELSE
          WITH This.standard
            .LeftMargin = This.marge_gauche
            .RightMargin = This.marge_droite
            .TopMargin = This.marge_haute
            .BottomMargin = This.marge_basse
            .IsLandscape = IIF(This.orientation=2, .T., .F.)
          ENDWITH  && This.standard
        ENDIF && ISNULL( This.standard)
      CATCH
        #IFDEF avec_ww
        WAIT WINDOW "problme lors du paramtrage de la page OO" NOWAIT
        #ENDIF
      ENDTRY
    ENDIF && ISNULL(This.page)
  ENDPROC && faire
  
ENDDEFINE && parametres_page AS Custom

DEFINE CLASS parametres_impression AS custom
  * cette classe ne contient que des proprits. A priori elle ne peut
  * tre utilise que par la classe VFP_OO et ses descendantes
  nombre_copie = 1
  impression_dans_un_fichier = .F.
  fichier_impression = ""   && par exemple SYS(5)+CURDIR()+ "essai.prn"
  previsualisation = .F.    && non encore utilis
  ordre_des_pages = .T.     && si plusieurs exemplaires : .T. on imprime d'abord
    * le document n 1, puis le document n 2 etc ...  .F. : on imprime toutes les
    * pages 1, puis toutes les pages 2, etc ...
  attente_fin = .T.         && par dfaut on attend que l'impression soit mise dans
    * la file d'attente (le spool) avant de continuer
  pages = ""                && liste des pages  imprimer. Vide si on imprime tout
    * sinon quelque chose comme "3;5;7-11" : impression des pages 3, 5 et de toutes celles
    * comprises entre 7 et 11
*!*    DIMENSION paramimp(5)        && tableau de paramtres pour OO obsolete
ENDDEFINE && parametres_impression AS custom

DEFINE CLASS entete_pied_de_page AS custom &&  jme 06/12/2007
  * gestion des enttes et des pieds de page d'un document WRITER
  * cette classe ne peut grer que des enttes ou des pieds de page
  *  sur une seule ligne (on pourrait crr des entetes/pieds sur
  *  plusieurs lignes mais on n'est pas capable de les relire)
  * pour l'instant on ne gre pas les polices de caractres
  * pour l'instant, on ne relit pas l'entete/pied existant
  * ATTENTION : cette classe gre l'entete ET le pied de page. Dans
  * une instance de oo_writer, on a deux pointeurs, un pour l'entete
  * l'autre pour le pied de page MAIS ILS POINTENT SUR LA MEME CLASSE.
  
  ya_entete = .F.            && .T. si on a un entte de page
  ya_pied = .F.              && .T. si on a un pied de page
  nom_style = ""             && nom du style de la page
  style = NULL               && style de la page
  liste_styles = NULL        && collection des styles de page
  txt = NULL                 && pointeur sur le curseur texte
  oow = NULL                 && pointeur sur l'instance de vfp_oo_writer
  police = NULL              && pointeur sur une instance de la classe oo_police
  erreur = -1                && erreur : -1 non initialis, 
  *                             -2 impossible de crer l'entte/pied de page (erreur OOo)
  *                             -3 chec cration entte/pied de page (erreur VFP)
  * 0 : cration pointeur russie, 1: cration entte russie, 2: cration pied russie
  * 3 : cration entte et pied russie
  position_bord_haut = 1000  && position de l'entte par rapport au haut de page
  hauteur_entete = 1000      && hauteur de l'entte (1000 = 1cm)
  entete_marge_gauche = 0    && distance entre la marge gauche et le bord gauche de l'entte
  entete_marge_droite = 0    && distance entre le bord droit de l'entte et la marge droite
  entete_gauche = ""         && texte  mettre  gauche de l'entte
  entete_centre = ""         && texte  centrer dans l'entte
  entete_droit = ""          && texte  mettre  droite dans l'entte
  position_bord_bas = 1000   && position du pied par rapport au bas de page
  hauteur_pied = 1000        && hauteur du pied (1000 = 1cm)
  pied_marge_gauche = 0      && distance entre la marge gauche et le bord gauche du pied
  pied_marge_droite = 0      && distance entre le bord droit du pied et la marge droite
  pied_gauche = ""           && texte  mettre  gauche du pied
  pied_centre = ""           && texte  centrer dans le pied
  pied_droit = ""            && texte  mettre  droite dans le pied
  
  PROTECTED PROCEDURE init( pooow, potexte )
    * pooow doit pointer sur une instance de la classe vfp_oo_writer
    * potexte doit pointer sur un curseur texte (en principe
    * vfp_oo_writer.cuecr
    
    IF PCOUNT()=0 OR ISNULL( m.pooow) OR VARTYPE(m.pooow) <> "O" ;
     OR ISNULL( m.potexte) OR VARTYPE(m.potexte) <> "O"
      #IFDEF avec_ww
      WAIT WINDOW "Impossible de crer un entte/pied de page" + CHR(13)+ ;
       "pointeur document writer ou texte incorrect" NOWAIT NOCLEAR
      #ENDIF
      RETURN .F.
    ELSE
      TRY
        * l'entte et le pied de page dpendent du style de la page sur laquelle on est
        * il faut donc le rcuprer (toutes les pages de mme style auront donc le mme
        * en-tte et pied de page).
        This.oow = m.pooow
        This.txt = m.potexte
        This.nom_style = This.txt.PageStyleName
        This.liste_styles = This.oow.doc.StyleFamilies.getByName("PageStyles")
        This.style = This.liste_styles.getByName( This.nom_style)
        IF ISNULL( This.style)
          This.erreur = -3 && cration  entte/pied impossible (erreur VFP)
          STORE NULL TO This.style, This.liste_styles
          STORE "" TO This.nom_style
          #IFDEF avec_ww
          WAIT WINDOW "Impossible de crer un entte/pied de page" + CHR(13)+ ;
           "erreur Openoffice.Org" NOWAIT NOCLEAR
          #ENDIF
        ELSE
          This.erreur = 1 && 1: cration entte russie
          * on a cr informatiquement un entete, cela ne veut pas dire qu'il existe 
          * rellement dans le document. Pour qu'il existe rellement dans le document,
          * la proprit HeaderIsOn doit contenir .T.
          * ATTENTION, on a AUSSI cr informatiquement un pied de page mais cela ne
          * veut pas dire qu'il existe rellement dans le document. Pour qu'il le soit
          * il faut que la proprit FooterIsOn contienne .T.
          * on prvoit pour l'entete / pied de page une autre police
          * si on n'y arrive pas, ce n'est pas une erreur, on ne fait rien
          TRY
            This.police = NEWOBJECT("oo_police", "", "", This.txt)
            * quand on ne met pas de module, VFP cherche dans les classes de base 
            * (mais oo_police n'y est pas) puis dans le programme courant
            IF !ISNULL( This.police)
              * on paramtre une police par dfaut
              This.police.nom = "Times New Roman"
              This.police.taille = 10
              This.police.faire()
            ENDIF && !ISNULL( This.police)
          CATCH
            This.police = NULL
            This.police.nom = ""
          ENDTRY
        ENDIF && ISNULL( This.style)
      CATCH
        This.erreur = -2 && cration  entte/pied impossible (erreur OOo)
        STORE NULL TO This.style, This.liste_styles, This.oow, This.txt
        STORE "" TO This.nom_style
        #IFDEF avec_ww
        WAIT WINDOW "Impossible de crer un entte/pied de page" + CHR(13)+ ;
         "le pointeur cr est NULL (erreur VFP)" NOWAIT NOCLEAR
        #ENDIF
      ENDTRY
    ENDIF && PCOUNT()=0 OR ISNULL( m.potexte) OR VARTYPE(m.potexte) <> "O"
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    
  ENDPROC && destroy
  
  PROCEDURE faire
    IF This.erreur > 0
      * on commence par traiter l'entte
      IF This.ya_entete
        LOCAL lotxt, locurseur && pointeurs sur la zone de texte de l'entte
        WITH This.style
          .HeaderIsOn = .T.
          .HeaderIsShared = .T.  && entete/pied page gauche = entete/pied page droite
          .HeaderLeftMargin = 0 && This.oow.page.marge_gauche
          .HeaderRightMargin = 0 && This.oow.page.marge_droite
          .HeaderTopBorderDistance = This.position_bord_haut
          .HeaderHeight = This.hauteur_entete
          .HeaderLeftBorderDistance = This.entete_marge_gauche
          .HeaderRightBorderDistance = This.entete_marge_droite
*!*            .Header = This.
          lotxt = .HeaderText
        ENDWITH  && This.style
        * provisoirement on efface l'ensemble de l'entete  l'init
        * (pose un problme si on rcupre un document ayant dj un entete ...)
        lotxt.String = "" && A SUPPRIMER
        locurseur = m.lotxt.createTextCursor()
        lotxt.insertString( m.locurseur, ;
         This.entete_gauche+ CHR(9)+ This.entete_centre +CHR(9)+ This.entete_droit, .F.)
      ELSE
        This.style.HeaderIsOn = .F.
      ENDIF && This.ya_entete
      
    ELSE
      #IFDEF avec_ww
      WAIT WINDOW "entte/pied de page ingrable" NOWAIT NOCLEAR
      #ENDIF
    ENDIF && This.erreur > 0
  ENDPROC && faire
ENDDEFINE && entete_pied_de_page

DEFINE CLASS vfp_oo AS custom
  * cette classe contient les proprits et les mthodes communes  tous les
  * types de document OpenOffice. Elle va tre, ventuellement, sous-classe
  * pour construire les classes correspondant au Writer (traitement de texte),
  *  Calc (feuille de calcul),  Draw (dessin) et  Impress (prsentation)
  
  oo_est_installe = .F.               && .T. si OpenOffice est install
  gestionnaire_de_services = NULL     && pointeur sur le ServiceManager d'OO
  doc = NULL                          && pointeur sur le document OO
  bureau = NULL                       && pointeur sur le 'bureau' d'OO (oo desktop
  fichier_courant = ""                && nom complet du fichier en cours de traitement
  imprimante = NULL                   && pointeur sur la classe parametres_imprimante
  impression = NULL                   && pointeur sur la classe parametres_impression
  cst_paragraph = NULL && essai
    
  abandon_document = .F. && pour les tests : si .T. on ne sauvegarde pas le document dans le destroy
  
  erreur = -1                         && -1 non encore initialis
  *  -2 OO n'est pas installable  -3 chec du createobject,  -4 impossible de crer le bureau
  *  -10  structure UNO impossible  crer, -11 paramtre invalide
  *  -13  impossible de fermer le document
  *  -20  impossible de crer le docuemnt,  -21  impossible de lire le document
  *  -30 et -31 Impossible de crer le pointeur sur le texte
  *  -32  Impossible de crer le curseur d'insertion texte

  PROTECTED PROCEDURE init
    *  l'init on vrifie si openoffice est install
    * une mthode PROTECTED est accessible par toutes les mthodes de la classe o
    * elle est dfinie mais aussi des mthodes des sous-classes mais pas du public
    * ATTENTION : cette classe peut tre instancie de nombreuses fois dans une mme
    *             application alors que le gestionnaire de services et le bureau 
    *             d'OpenOffice.org ne doivent l'tre qu'une seule fois. On vrifie
    *             donc si on est en train d'instancier cette classe pour la 1re fois.
    LOCAL lnnbinst
    LOCAL ARRAY ltinstances(1)
    
    lnnbinst = AINSTANCE(ltinstances, "vfp_oo") && jme 05/12/2007
    IF m.lnnbinst > 0
      IF m.lnnbinst >1
        #IFDEF avec_ww
        WAIT WINDOW "nombre d'instances:"+ STR(m.lnnbinst,3)+ ;
         CHR(13)+ ltinstances(1) + "  "+ ltinstances(2) NOWAIT NOCLEAR
        #ENDIF
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "dj une instance" + CHR(13)+ ltinstances(1) NOWAIT NOCLEAR
        #ENDIF
      ENDIF && m.lnnbinst >1
      * ce n'est pas la premire instance de cette classe, comme on ne doit avoir
      * qu'un seul gestionnaire de services et un seul bureau, on reprend ceux
      * crs dans la premire instance
      LOCAL lopointeur
      lopointeur = &ltinstances(1)
      IF m.lopointeur.erreur >=2
        This.gestionnaire_de_services = m.lopointeur.gestionnaire_de_services
        This.bureau = m.lopointeur.bureau
        COMARRAY( This.bureau, 10 ) && The array is a zero-based array and is passed by reference
        This.erreur = 2 && ok
        This.imprimante = NEWOBJECT("parametres_imprimante")
        This.impression = NEWOBJECT("parametres_impression")
      ELSE
        This.erreur = m.lopointeur.erreur
      ENDIF && m.lopointeur.erreur >=2
    ELSE
      #IFDEF avec_ww
      WAIT WINDOW "premire instance" NOWAIT NOCLEAR
      #ENDIF
      * c'est la premire instance de cette classe, il faut crer le gestionnaire
      * de services et le bureau
      TRY
        This.gestionnaire_de_services = CREATEOBJECT( "com.sun.star.ServiceManager" )
        IF ISNULL(This.gestionnaire_de_services)
          #IFDEF avec_ww
          WAIT WINDOW "erreur instanciation OO" NOWAIT NOCLEAR
          #ENDIF
          This.erreur = -3
        ELSE
          This.erreur = 1
        ENDIF && ISNULL(This.gestionnaire_de_services)
      CATCH
        #IFDEF avec_ww
        WAIT WINDOW "Impossible d'instancier OO" NOWAIT NOCLEAR
        #ENDIF
        This.erreur = -2
      ENDTRY
      * on va maintenant ouvrir le bureau d'OO
      IF This.erreur = 1
        TRY
          This.bureau = ;
           This.gestionnaire_de_services.createInstance( "com.sun.star.frame.Desktop" )
          COMARRAY( This.bureau, 10 ) &&The array is a zero-based array and is passed by reference
          *!*  * on pourrait cacher la fentre oO :  voir
          *!*  oDesk = oServiceManager.createInstance("com.sun.star.frame.Desktop")
          *!*  aArgs(1) = MakeOOPropertyValue(oServiceManager, "Hidden", .T.)
          This.erreur = 2 && ok
          This.imprimante = NEWOBJECT("parametres_imprimante")
          This.impression = NEWOBJECT("parametres_impression")
        CATCH
          #IFDEF avec_ww
          WAIT WINDOW "impossible d'instancier le bureau OO" NOWAIT NOCLEAR
          #ENDIF
          This.bureau = NULL
          This.erreur = -4
        ENDTRY
      ENDIF && This.erreur = 1
    ENDIF && m.lnnbinst > 0
*!*      TRY
*!*        This.gestionnaire_de_services = CREATEOBJECT( "com.sun.star.ServiceManager" )
*!*        IF ISNULL(This.gestionnaire_de_services)
*!*          #IFDEF avec_ww
*!*          WAIT WINDOW "erreur instanciation OO" NOWAIT
*!*          #ENDIF
*!*          This.erreur = -3
*!*        ELSE
*!*          This.erreur = 1
*!*        ENDIF && ISNULL(This.gestionnaire_de_services)
*!*      CATCH
*!*        #IFDEF avec_ww
*!*        WAIT WINDOW "Impossible d'instancier OO" NOWAIT
*!*        #ENDIF
*!*        This.erreur = -2
*!*      ENDTRY
*!*      * on va maintenant ouvrir le bureau d'OO
*!*      * note je ne sais pas si on doit avoir un bureau par document
*!*      * ou un bureau par instance d'OO (donc a priori un seul). pour
*!*      * tester je vais en crer qu'un seul donc ici dans l'init
*!*      IF This.erreur = 1
*!*        TRY
*!*          This.bureau = ;
*!*           This.gestionnaire_de_services.createInstance( "com.sun.star.frame.Desktop" )
*!*          COMARRAY( This.bureau, 10 ) &&The array is a zero-based array and is passed by reference
*!*          This.erreur = 2 && ok
*!*          This.imprimante = NEWOBJECT("parametres_imprimante")
*!*          This.impression = NEWOBJECT("parametres_impression")
*!*        CATCH
*!*          #IFDEF avec_ww
*!*          WAIT WINDOW "impossible d'instancier le bureau OO" NOWAIT
*!*          #ENDIF
*!*          This.bureau = NULL
*!*          This.erreur = -4
*!*        ENDTRY
*!*      ENDIF && This.erreur = 1
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    * une mthode PROTECTED est accessible par toutes les mthodes de la classe o
    * elle est dfinie mais aussi des mthodes des sous-classes mais pas du public
    IF !ISNULL(This.doc) AND This.doc.isModified AND This.abandon_document=.F.
      * si on n'a pas de nom de fichier quand on sort, on en crer un automatiquement
      IF EMPTY(This.fichier_courant)
        This.fichier_courant = "OOO_OO_"+ SYS(2015)
      ENDIF && EMPTY(This.fichier_courant)
      This.enregistrer_document()
    ENDIF && This.doc.isModified
    This.doc = NULL
    This.bureau = NULL
    This.gestionnaire_de_services = NULL
  ENDPROC
  
  PROCEDURE nouveau_document( pctypdoc AS String)
    * on cre un nouveau document dont le type est contenu dans pctypdoc
    * nouveau texte : pctypdoc = "private:factory/swriter"
    * nouveau tableur : pctypdoc = "private:factory/scalc"
    * nouveau dessin :  pctypdoc = "private:factory/sdraw"
    * nouvelle prsentation :  pctypdoc = "private:factory/simpress"
    * nouvelles formules mathmatiques :  pctypdoc = "private:factory/smath"
    
    IF This.erreur >=0 AND !EMPTY(m.pctypdoc)
      * on ne cre pas de nouveau document s'il y en a dj un actif
      IF ISNULL(This.doc)
        This.erreur = 0
        This.OOoOpenURL( m.pctypdoc ) && met  jour This.doc
        IF ISNULL(This.doc)
          This.erreur = -20
          #IFDEF avec_ww
          WAIT WINDOW "Impossible de crer un nouveau document" NOWAIT
          #ENDIF
        ELSE
          This.erreur = 2 && document ok
          This.abandon_document=.F. && on met .T. quand on ne veut pas que le
          * document soit enregistrer dans le destroy event; il faut donc
          * bien penser  la remettre  faux lors de la cration d'un nouveau
          * document
        ENDIF && ISNULL(This.doc)
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "Cration nouveau document impossible" + CHR(13)+ ;
         "un autre existe dj" NOWAIT
        #ENDIF
      ENDIF && ISNULL(This.doc)
    ENDIF && This.erreur =2
  ENDPROC
  
  PROCEDURE ouvrir_document( pcfichier AS String)
    * pcfichier est un nom de fichier 00 au format Windows ("c:\toto\tata\tutu.odt")
    LOCAL ARRAY lttab(1)
    LOCAL lcurl
    
    IF This.erreur<2 OR EMPTY(m.pcfichier)
      This.erreur = -11 && paramtre invalide
      #IFDEF avec_ww
      WAIT WINDOW "Il faut indiquer le nom du fichier  ouvrir" NOWAIT
      #ENDIF
    ELSE
      * on demande  VFP de vrifier que le fichier existe bien avant de l'ouvrir
      IF ADIR(lttab, m.pcfichier) > 0
        This.erreur = 0 && on raz l'erreur ventuelle
        This.doc = NULL
        lcurl = This.OOoConvertToURL( m.pcfichier )
        This.OOoOpenURL( m.lcurl ) && met  jour This.doc
        IF ISNULL( This.doc)
          This.erreur = -21
          #IFDEF avec_ww
          WAIT WINDOW "Impossible d'ouvrir le fichier" + CHR(13)+ ;
           m.pcfichier NOWAIT
          #ENDIF
        ELSE
          This.erreur = 2 && document ok
          This.abandon_document=.F. && on met .T. quand on ne veut pas que le
          * document soit enregistrer dans le destroy event; il faut donc
          * bien penser  la remettre  faux lors de l'ouverture d'un nouveau
          * document
        ENDIF && ISNULL( This.doc)
      ELSE
        This.erreur = -20
        #IFDEF avec_ww
        WAIT WINDOW "Le fichier" + CHR(13)+ m.pcfichier+ CHR(13)+ ;
         "n'existe pas"NOWAIT
        #ENDIF
      ENDIF && ADIR(lttab, m.pcfichier) > 0
    ENDIF && EMPTY(pcfichier)
  ENDPROC && ouvrir_texte

  PROCEDURE enregistrer_document( pcnomfichier AS String)  && vfp_oo
    * attention, si vous travaillez sur un document TOTO et que vous
    * l'enregistrez sous le nom TATA, vous travaillerez dornavant sur TATA
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * on ne peut pas exporter en PDF avec storeasurl()
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      This.fichier_courant = m.pcnomfichier
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
    * on pourrait tester si le document a t modifi avec la proprit 
    *  This.doc.isModified (cette proprit est en lecture/criture)
    IF EMPTY( JUSTPATH(This.fichier_courant))
      * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
      This.fichier_courant = SYS(5)+ CURDIR()+ This.fichier_courant
    ENDIF && EMPTY( JUSTPATH(This.fichier_courant))
    LOCAL lcurl, lcext
    LOCAL ARRAY lcparam(1)
    lcext = JUSTEXT(This.fichier_courant)
    * on veut prvenir l'oprateur s'il crase une version prcdente du document
    * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
    *  cette option ou effacer le fichier destinataire avant de faire l'enregistrement)
    lcparam(1) = This.OOoPropertyValue( "Overwrite", .F. )
    lcurl = This.OOoConvertToURL( This.fichier_courant)
    This.doc.storeAsURL( m.lcurl, @ lcparam)
  ENDPROC && enregistrer_document
  
  PROCEDURE enregistrer_copie_document( pcnomfichier AS String)
    * on veut crer une copie du document courant (on cre un fichier
    * sur le disque mais on continue de travailler sur le document courant)
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * attention la mthode storeToURL est diffrente de storeAsURL
    * avec cette mthode on pourrait exporter en PDF, mais, comme les paramtres
    * dpendent du type de document, on va faire une mthode hrite dans
    * vfp_oo_writer pour un document texte et dans vfp_oo_calc pour une feuille de calcul.
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      IF EMPTY( JUSTPATH(m.pcnomfichier))
        * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
        pcnomfichier = SYS(5)+ CURDIR()+ m.pcnomfichier
      ENDIF && EMPTY( JUSTPATH(m.pcnomfichier))
      LOCAL lcurl
      LOCAL ARRAY lcparam(1)
      * on veut prvenir l'oprateur s'il crase une version prcdente du document
      * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
      *  cette option)
      lcparam(1) = This.OOoPropertyValue( "Overwrite", .T. )
      lcurl = This.OOoConvertToURL( m.pcnomfichier )
      This.doc.storeToURL( m.lcurl, @ lcparam)
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
  ENDPROC && enregistrer_document
  
  PROCEDURE fermer_document
    LOCAL llok
    
    llok = .T.
    IF This.doc.isModified
      llok = IIF( INLIST( MESSAGEBOX("Le document" + CHR(13)+ This.fichier_courant + ;
       CHR(13)+ "n'a pas t enregistr." + CHR(13)+ "Voulez-vous l'enregistrer ?", ;
        4+32, "ATTENTION", 60000), -1,6), .T., .F.)
    ENDIF && This.doc.isModified
    IF m.llok = .T.
      TRY
        This.doc.close(.T.)
        This.abandon_document=.T. && on ne veut pas enregistrer dans le destroy
        This.doc = NULL
        This.erreur = 1
      CATCH
        This.erreur = -13 && impossible de fermer le document
        #IFDEF avec_ww
        WAIT WINDOW "Impossible de fermer le document" NOWAIT
        #ENDIF
      ENDTRY
    ENDIF && m.llok = .T.
  ENDPROC && fermer_document()
  
  PROCEDURE imprimer_document
    * ATTENTION : il faut normalement 5 paramtres pour piloter l'impression. Ces
    * 5 paramtres sont mmoriss dans l'instance de parametres_impression pointe
    * par This.impression. Lorsqu'un paramtre est vide (comme filename si on
    * imprime sur l'imprimante ou pages si on veut tout imprimer), il ne doit PAS
    * tre transmis. La dimension du tableau transmis  OO est donc variable et
    * dpend du nombre de paramtres utiles.
    
*!*      ci dessous un bout de code pour imprimer les proprits de printer et leur valeur    
*!*      loprinter = This.doc.printer
*!*      lnaccu = ALEN(loprinter)
*!*      SET TEXTMERGE TO essai_printer.txt ADDITIVE NOSHOW
*!*      SET TEXTMERGE ON
*!*      \<<DATE()>> <<TIME()>>
*!*      lcaccu = ""
*!*      FOR m.lni = 1 TO m.lnaccu
*!*         *lcaccu = m.lcaccu+loprinter(m.lni).name+ CHR(13)
*!*         IF VARTYPE(loprinter(m.lni).value) <> "O"
*!*           \  <<loprinter(m.lni).name>> : <<loprinter(m.lni).value>>
*!*         ELSE
*!*           \  <<loprinter(m.lni).name>> : objet
*!*         ENDIF && VARTYPE(loprinter(m.lni).value) <> "O"
*!*      ENDFOR &&* m.lni = 1 TO m.lnaccu
*!*      SET TEXTMERGE OFF
*!*      SET TEXTMERGE TO
    
    WITH This.impression
      DO CASE
      CASE .impression_dans_un_fichier AND EMPTY(.pages)
        * impression de tout le document dans un fichier
        LOCAL ARRAY loparam(4)
        loparam(4) = This.OOoPropertyValue( "FileName", .fichier_impression)
      CASE .impression_dans_un_fichier AND !EMPTY(.pages)
        * impression d'une liste de pages du document dans un fichier
        LOCAL ARRAY loparam(5)
        loparam(5) = This.OOoPropertyValue( "FileName", .fichier_impression)
        loparam(4) = This.OOoPropertyValue( "Pages", .pages)
      CASE !.impression_dans_un_fichier AND EMPTY(.pages)
        * impression de tout le document sur l'imprimante
        LOCAL ARRAY loparam(3)
      CASE !.impression_dans_un_fichier AND !EMPTY(.pages)
        * impression d'une liste de pages du document sur l'imprimante
        LOCAL ARRAY loparam(4)
        loparam(4) = This.OOoPropertyValue( "Pages", .pages)
      ENDCASE
      loparam(1) = This.OOoPropertyValue( "CopyCount", .nombre_copie) && faut expliquer ?
      * Collate : si plusieurs exemplaires : .T. on imprime d'abord le document n 1, 
      * puis le document n 2 etc ...  .F. : on imprime toutes les pages 1, puis toutes 
      * les pages 2, etc ...
      loparam(2) = This.OOoPropertyValue( "Collate", .ordre_des_pages)
      loparam(3) = This.OOoPropertyValue( "Wait", .attente_fin)
    ENDWITH  && This.impression
    This.doc.Print( @loparam)
  ENDPROC && imprimer_document
  
  PROCEDURE informations_document
    LOCAL lcfichier, loinfos, lodate
    IF !ISNULL(This.doc)
      lcfichier = This.doc.location
      loinfos = This.doc.documentInfo
      lodate = loinfos.CreationDate
      = MESSAGEBOX("document :"+ m.lcfichier+ CHR(13)+ ;
       "auteur: "+ m.loinfos.Author+ CHR(13)+ ;
       "cration: "+ STR(m.lodate.Day,2)+"/"+ TRANSFORM(m.lodate.Month, "@L 99")+ ;
        "/"+ STR(m.lodate.Year,4)+ CHR(13), 0, "informations")
    ENDIF && !ISNULL(This.doc)
  ENDPROC && informations_document
  
*********************************************************  
* ci-dessous : toutes les mthodes 'utilitaires'
*********************************************************
  * ben, pour l'instant, il y en a plus !!

*********************************************************  
* ci-dessous : toutes les mthodes OO utilises ci-dessus
*********************************************************
* HIDDEN : la mthode ne peut tre appele que depuis cette classe. Mme
*          les sous-classes de vfp_oo ne peuvent pas y accder.

  PROTECTED PROCEDURE OOoOpenURL( pcURL )
    * Ouvre ou cre un document  partir de son URL.
    * Pour crer un nouveau document, l'URL est :
    *  private:factory/sdraw  pour un nouveau document de dessin
    *  private:factory/swriter pour un nouveau document texte
    *  private:factory/scalc  pour un nouveau classeur de feuilles de calcul
    *  private:factory/simpress && pour un nouveau document de prsentation

*!*        *  LOCAL oPropertyValue
*!*        *  oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
*!*        *  LOCAL ARRAY aNoArgs[1]
*!*        *  aNoArgs[1] = oPropertyValue
*!*        *  aNoArgs[1].Name = "ReadOnly"
*!*        *  aNoArgs[1].Value = .F.
*!*        * These two lines replace the alternate version above,
*!*        *  which are left commented for the insight they provide.
    LOCAL ARRAY aNoArgs[1]
    * grossirement : on cre une structure contenant la proprit 'hidden'
    *  initialise  .F. et dont l'adresse est dans le premier lment de anoargs
    aNoArgs[1] = This.OOoPropertyValue( "Hidden", .F. )
    This.doc = This.bureau.LoadComponentFromUrl( m.pcURL, "_blank", 0, @aNoargs )
    * Make sure that arrays passed to this document are passed zero based and through
    * reference
    * COMARRAY indique  VFP que tous les tableaux passs  this.doc doivent tre
    * bass sur 0 (le premier lment a pour indice 0 et non 1) et tre passs par
    * rfrence. Toutefois, malgr cette instruction (bug ?) les tableaux doivent tre
    * prcds par @ si on veut que VFP les passe par rfrence.
    COMARRAY( This.doc, 10 )
  ENDPROC
  
  FUNCTION OOoPropertyValue( cName, uValue, nHandle, nState )
    * Create a com.sun.star.beans.PropertyValue struct and return it.
    * crer une structure du type com.sun.star.beans.PropertyValue et
    * retourne un pointeur
    * la structure utilise par OO ne peut pas tre cre directement en VFP
    * on va donc demander  OO de la crer pour nous
    LOCAL oPropertyValue
    oPropertyValue = This.OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
    oPropertyValue.Name = m.cName
    oPropertyValue.Value = m.uValue
    * si on a des paramtres supplmentaires, on les traite
    IF TYPE([nHandle])="N"
      oPropertyValue.Handle = m.nHandle
    ENDIF
    IF TYPE([nState])="N"
      oPropertyValue.State = m.nState
    ENDIF
    RETURN m.oPropertyValue
  ENDFUNC

  FUNCTION OOoCreateStruct( cTypeName AS String)
    * fonction pour crer n'importe quel type de structure UNO
    * on l'a fait crer par OO
    LOCAL oStruct
    oStruct = .NULL.
    TRY
      oStruct = This.gestionnaire_de_services.Bridge_GetStruct( m.cTypeName )
    CATCH
      WAIT WINDOW "impossible de crer la structure" TIMEOUT 2
      oStruct = NULL
      This.erreur = -10 && structure UNO impossible  crer
    ENDTRY
    * dans les exemples lus, il semble qu'il pouvait y avoir un problme si certaines
    * variables globales taient dj mises  jour. Pour l'instant, je supprime
    * cette partie
*!*      IF ISNULL( m.oStruct )
*!*        * on n'a pas russi  crer la structure, on essaie de corriger un problme
*!*        * et de recommencer
*!*        =__OOoReleaseCachedVars()
*!*        oServiceManager = OOoGetServiceManager()
*!*        oStruct = oServiceManager.Bridge_GetStruct( cTypeName )
*!*      ENDIF && ISNULL( m.oStruct )
    RETURN m.oStruct
  ENDFUNC && OOoCreateStruct( cTypeName )

  FUNCTION OOoConvertToURL( cFilename AS String)
    * convertit un nom de fichier Windows en un nom OO
    * le nom doit commencer par "/" et il faut changer les \ en /
    RETURN "file://" + IIF(ASC(m.cFilename)=47, "", "/")+ ;
     CHRTRAN( m.cFilename, "\", "/" )
  ENDFUNC
  
ENDDEFINE && vfp_oo


DEFINE CLASS vfp_oo_writer AS vfp_oo && jme 04/11/2007
  * cette classe contient les proprits et les mthodes propres au
  * document Writer (traitement de texte) d'openOffice
  
  texte = NULL                        && pointeur sur le texte du document
  cuecr = NULL                        && curseur criture
  cureel = NULL                       && curseur visible (le clignotant)
  font = NULL                         && pointeur sur la classe police
  paragraphe = NULL                   && pointeur sur la classe paragraphe
  page = NULL                         && pointeur sur la classe parametres_page
  entete_pied = NULL                  && pointeur sur la classe entete_pied_de_page
  entete = NULL                       && pointeur sur la classe entete_pied_de_page
  pied = NULL                         && pointeur sur la classe entete_pied_de_page
  * ATTENTION : entete et pied pointent, s'ils ne sont pas NULL, sur la mme classe
  *             parce qu'au point de vue OpenOffice.org c'est un seul objet alors
  *             qu'ici, pour plus de clart, on les spare
  recherche = NULL                     && paramtres d'une recherche de texte
  resultats = NULL                     && rsultats de certaines procdures (rechercher, ....)
  nombre_resultats = 0                 && nombre de rsultats  
*  erreur = -1                         && -1 non encore initialis
  *  -30 et -31 Impossible de crer le pointeur sur le texte
  *  -32  Impossible de crer le curseur d'insertion texte

  PROTECTED PROCEDURE init
    *  l'init on vrifie si openoffice est install
    DODEFAULT()
    IF This.erreur = 2
      * initialisation propre au Writer
    ENDIF && This.erreur = 2
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    IF !ISNULL(This.doc) AND This.abandon_document=.F. AND This.doc.isModified
      * si on n'a pas de nom de fichier quand on sort, on en crer un automatiquement
      IF EMPTY(This.fichier_courant)
        This.fichier_courant = "OOO_WRITER_"+ SYS(2015)
      ENDIF && EMPTY(This.fichier_courant)
      This.enregistrer_document()
    ENDIF && This.doc.isModified
    This.doc = NULL
    DODEFAULT()
  ENDPROC
  
  PROCEDURE nouveau_document_texte
    * on cre un nouveau document texte
    IF This.erreur =2
      * on ne cre pas de nouveau document s'il y en a dj un actif
      IF ISNULL(This.doc)
        This.nouveau_document( "private:factory/swriter" )
        IF ISNULL(This.doc)
          * il n'y a rien  faire ici, l'erreur a dj t donne
        ELSE
          This.texte = This.doc.Text && pointeur sur le texte du document
          * note le texte est le contenu du document. D'autres pointeurs 
          * existent pour l'en-tte, le pied de page, etc ....
          IF ISNULL(This.texte)
            This.erreur = -30
            #IFDEF avec_ww
            WAIT WINDOW "Impossible de crer le pointeur sur le texte" NOWAIT
            #ENDIF
          ELSE
            This.cuecr = This.texte.createTextCursor()
            IF ISNULL(This.cuecr)
              This.erreur = -32
              #IFDEF avec_ww
              WAIT WINDOW "Impossible de crer le curseur d'insertion texte" NOWAIT
              #ENDIF
            ELSE
              This.erreur = 2 && tout va bien
              This.objets_doc()
            ENDIF && ISNULL(This.cuecr)
          ENDIF && ISNULL(This.texte)
        ENDIF && ISNULL(This.doc)
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "Cration nouveau document impossible" + CHR(13)+ ;
         "un autre existe dj" NOWAIT
        #ENDIF
      ENDIF && ISNULL(This.doc)
    ENDIF && This.erreur =2
  ENDPROC
  
  PROCEDURE ouvrir_document_texte( pcfichier AS String)
    * pcfichier est un nom de fichier document text au format Windows
    LOCAL ARRAY lttab(1)
    LOCAL lcurl
    
    IF EMPTY(m.pcfichier)
      This.erreur = -11 && paramtre invalide
      WAIT WINDOW "Il faut indiquer le nom du fichier  ouvrir" NOWAIT
    ELSE
      IF ADIR(lttab, m.pcfichier) > 0
        This.erreur = 0 && on raz l'erreur ventuelle
        This.doc = NULL
        lcurl = This.OOoConvertToURL( m.pcfichier )
        This.OOoOpenURL( m.lcurl )
        IF ISNULL( This.doc)
          This.erreur = -21
          #IFDEF avec_ww
          WAIT WINDOW "Impossible d'ouvrir le fichier" + CHR(13)+ ;
           m.pcfichier NOWAIT
          #ENDIF
        ELSE
          This.texte = This.doc.Text && pointeur sur le texte du document
          * note le texte est le contenu du document. D'autres pointeurs 
          * existent pour l'en-tte, le pied de page, etc ....
          IF ISNULL(This.texte)
            This.erreur = -31
            #IFDEF avec_ww
            WAIT WINDOW "Impossible de crer le pointeur sur le texte" NOWAIT
            #ENDIF
          ELSE
            This.cuecr = This.texte.createTextCursor()
            IF ISNULL(This.cuecr)
              This.erreur = -32
              #IFDEF avec_ww
              WAIT WINDOW "Impossible de crer le curseur d'insertion texte" NOWAIT
              #ENDIF
            ELSE
              This.erreur = 2 && tout va bien
              This.objets_doc()
            ENDIF && ISNULL(This.cuecr)
          ENDIF && ISNULL(This.texte)
        ENDIF && ISNULL( This.doc)
      ELSE
        This.erreur = -20
        #IFDEF avec_ww
        WAIT WINDOW "Le fichier" + CHR(13)+ m.pcfichier+ CHR(13)+ ;
         "n'existe pas"NOWAIT
        #ENDIF
      ENDIF && ADIR(lttab, m.pcfichier) > 0
    ENDIF && EMPTY(pcfichier)
  ENDPROC && ouvrir_texte
  
  PROTECTED PROCEDURE objets_doc
    * met  jour les pointeurs et les paramtres utiliss pour manipuler le texte
    This.font = NEWOBJECT("oo_police", "", "", This.cuecr) && quand on ne met pas de module,
    *  VFP cherche dans les classes de base (mais oo_police n'y est pas) puis
    *  dans le programme courant
    This.paragraphe = NEWOBJECT("oo_paragraphe", "", "", This.cuecr) && idem
    * This.font sert pour la gestion des polices de caractres
    * This.paragraphe sert pour la gestion des paragraphes
    This.page = NEWOBJECT("parametres_page", "", "", This.doc)
    * This.page sert  grer les valeurs de marge haute, marge basse, gauche et
    * droite de la page.
  ENDPROC && objets_doc

  PROCEDURE enregistrer_copie_document( pcnomfichier AS String)  && vfp_oo_writer
    * on veut crer une copie du document texte courant (on cre un fichier
    * sur le disque mais on continue de travailler sur le document courant)
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * on va crer systmatiquement un export  PDF
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      IF EMPTY( JUSTPATH(m.pcnomfichier))
        * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
        pcnomfichier = SYS(5)+ CURDIR()+ m.pcnomfichier
      ENDIF && EMPTY( JUSTPATH(m.pcnomfichier))
      DODEFAULT( m.pcnomfichier)
      LOCAL lcurl
      LOCAL ARRAY lcparam(2)
      * on veut prvenir l'oprateur s'il crase une version prcdente du document
      * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
      *  cette option ou supprimer le PDF avant de lancer cette mthode)
      lcparam(2) = This.OOoPropertyValue( "Overwrite", .T. )
      lcparam(1) = This.OOoPropertyValue( "FilterName", "writer_pdf_Export")
      * il faut enlever l'ventuelle extension du nom du fichier pour la remplacer par .pdf
      lcurl = This.OOoConvertToURL( JUSTPATH(m.pcnomfichier)+ "\"+ JUSTSTEM(m.pcnomfichier)+ ".pdf")
      This.doc.storeToURL( m.lcurl, @ lcparam)
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
  ENDPROC && enregistrer_document
  
  PROCEDURE informations_document
    LOCAL lcfichier, loinfos, lodate
    IF !ISNULL(This.doc)
      lcfichier = This.doc.location
      loinfos = This.doc.documentInfo
      lodate = loinfos.CreationDate
      = MESSAGEBOX("document :"+ m.lcfichier+ CHR(13)+ ;
       "auteur: "+ m.loinfos.Author+ CHR(13)+ ;
       "cration: "+ STR(m.lodate.Day,2)+"/"+ TRANSFORM(m.lodate.Month, "@L 99")+ ;
        "/"+ STR(m.lodate.Year,4)+ CHR(13)+ ;
       "nombre de mots: "+ ALLTRIM(STR(This.doc.WordCount,6)), 0, "informations")
    ENDIF && !ISNULL(This.doc)
  ENDPROC && informations_document
  
  PROCEDURE debut_texte
    This.cuecr.gotoStart(.F.)
  ENDPROC
  
  PROCEDURE ajouter_texte( pctexte AS String)
    This.texte.insertString( This.cuecr, m.pctexte, .F.)
  ENDPROC && ajouter_texte
  
  PROCEDURE nouveau_paragraphe && insertion d'un nouveau paragraphe
    *  l'endroit du curseur d'criture
    * "com.sun.star.text.ControlCharacter.PARAGRAPH_BREAK"
    This.texte.insertControlCharacter(This.cuecr, PARAGRAPH_BREAK, .F.)
  ENDPROC && nouveau_paragraphe
  
  PROCEDURE retour_ligne && retour  la ligne en restant dans le mme paragraphe
    * "com.sun.star.text.ControlCharacter.LINE_BREAK"
    This.texte.insertControlCharacter(This.cuecr, LINE_BREAK, .F.)
  ENDPROC && nouveau_paragraphe
  
  PROCEDURE appliquer_police && applique la police dfinie dans la
    * classe police
    This.font.curseur_ecriture = This.cuecr
    This.font.faire()
  ENDPROC && appliquer_police
  
  PROCEDURE police( pcnompolice AS String, ;
   pntaille AS Number, plgras AS Logical, plsouligne AS Logical)
    IF PCOUNT()>0 AND !ISNULL(m.pcnompolice) AND !EMPTY(m.pcnompolice)
      This.font.nom = m.pcnompolice
    ENDIF
    IF PCOUNT()>1 AND !ISNULL(m.pntaille) AND BETWEEN(m.pntaille, 2, 99)
      This.font.taille = m.pntaille
    ENDIF
    IF PCOUNT()>2 AND !ISNULL(m.plgras)
      This.font.gras = m.plgras
    ENDIF
    IF PCOUNT()>3 AND !ISNULL(m.plsouligne)
      This.font.souligne = m.plsouligne
    ENDIF
    This.font.curseur_ecriture = This.cuecr
    This.font.faire()
  ENDPROC && police
  
  PROCEDURE creer_entete && on crer veut un entte de page
    IF ISNULL( This.entete) AND ISNULL( This.pied)
      * on n'a pas encore crer d'entte / pied de page, il faut le faire
      * (on peut avoir cr un pied de page, auquel cas this.pied n'est
      *  pas nul, mais pas encore d'entte)
      This.entete = NEWOBJECT("entete_pied_de_page", "", "", This, This.cuecr)
    ELSE
      IF ISNULL( This.entete)
        This.entete = This.pied
      ELSE
        * normalement on ne devrait jamais passer ici, cela voudrait dire que l'on
        * veut crer un nouvel entete alors qu'il en existe dj un
      ENDIF && ISNULL( This.entete)
    ENDIF && ISNULL( This.entete_pied)
    IF !ISNULL( This.entete)
*!*        STORE This.entete_pied TO This.entete, This.pied
      WITH This.entete
        IF .erreur >=1
          .ya_entete = .T.            && .T. si on a un entte de page
          .faire()
        ENDIF && .erreur >=1
      ENDWITH  && This.entete_pied
    ENDIF && !ISNULL( This.entete_pied)
  ENDPROC && creer_entete
  
  PROCEDURE parametrage_entete( pnposition AS Number, pnhauteur AS Number, ;
   pnmargegauche AS Number, pnmargedroite AS Number)
    * on exige les 4 paramtres mais seuls ceux qui sont numriques sont pris 
    * en compte
    IF PCOUNT() = 4
      IF !ISNULL(m.pnposition) AND VARTYPE(m.pnposition)=="N"
        * position de l'entte par rapport au haut de page
        This.entete.position_bord_haut = m.pnposition
      ENDIF
      IF !ISNULL(m.pnhauteur) AND VARTYPE(m.pnhauteur)=="N"
        * hauteur de l'entte (1000 = 1cm)
        This.entete.hauteur_entete = m.pnhauteur
      ENDIF
      IF !ISNULL(m.pnmargegauche) AND VARTYPE(m.pnmargegauche)=="N"
        * distance entre la marge gauche et le bord gauche de l'entte
        This.entete.entete_marge_gauche = m.pnmargegauche
      ENDIF
      IF !ISNULL(m.pnmargedroite) AND VARTYPE(m.pnmargedroite)=="N"
        * distance entre le bord droit de l'entte et la marge droite
        This.entete.entete_marge_droite = m.pnmargedroite
      ENDIF
      This.entete.faire()
    ENDIF && PCOUNT() = 4
  ENDPROC && parametrage_entete
  
  PROCEDURE textes_entete( pcgauche AS String, pcmilieu AS String, pcdroite AS String)
    IF PCOUNT() >= 1
      IF !ISNULL(m.pcgauche) AND VARTYPE(m.pcgauche)=="C"
        This.entete.entete_gauche = m.pcgauche && texte  mettre  gauche de l'entte
      ENDIF
    ENDIF && PCOUNT() >= 1
    IF PCOUNT() >= 2
      IF !ISNULL(m.pcmilieu) AND VARTYPE(m.pcmilieu)=="C"
        This.entete.entete_centre = m.pcmilieu && texte  centrer dans l'entte
      ENDIF
    ENDIF && PCOUNT() >= 2
    IF PCOUNT() >= 3
      IF !ISNULL(m.pcdroite) AND VARTYPE(m.pcdroite)=="C"
        This.entete.entete_droit = m.pcdroite && texte  mettre  droite dans l'entte
      ENDIF
    ENDIF && PCOUNT() >= 1
    This.entete.faire()
  ENDPROC && textes_entete
  
  FUNCTION rechercher_premier( pctexte AS String, plmotentier AS Logical) && jme 20/10/2008
    * recherche le contenu de pctexte partout dans le document (donc y compris
    * dans l'entte, pied de page, .... en fait cela parait faux)
    * pctexte contient le texte  rechercher
    * plmotentier = .T. si on cherche un mot entier
    * a priori on ne tient pas compte de la casse (majuscule / minuscule) mais c'est  vrifier
    LOCAL lorecherche
    
    This.recherche = This.doc.createSearchDescriptor()
    WITH m.This.recherche
      .SearchString = m.pctexte
      .SearchWords = m.plmotentier
    ENDWITH && m.lorecherche
    * je RAZ le rsultat prcdent car je ne suis pas sr de ce qu'il se passe dans
    * findall si on ne trouve aucune occurence du texte recherch
    This.resultats = NULL
    This.nombre_resultats = 0
    This.resultats = This.doc.findFirst( m.This.recherche)
    IF ! ISNULL( This.resultats)
      This.nombre_resultats = This.nombre_resultats + 1
      * ATTENTION PROVISOIRE !
      * pour les tests, il faut bien que je 'marque' les zones de texte trouves
      * mais en ralit il ne faut pas le faire, on obtient un curseur texte qui
      * contient la chaine trouve et sur lequel on peut faire des traitements
      This.resultats.CharBackColor = 1234567 && fond vert sombre
      RETURN .T.
    ELSE
      RETURN .F.
    ENDIF && ! ISNULL( This.resultats)
  ENDFUNC && rechercher_premier
  
  FUNCTION rechercher_suivant
    * recherche l'occurence suivante du texte paramtr dans rechercher_premier
    IF ! ISNULL( This.resultats)
      This.resultats = This.doc.findNext( m.This.resultats.end, m.This.recherche)
      IF ! ISNULL( This.resultats)
        This.nombre_resultats = This.nombre_resultats + 1
        * ATTENTION PROVISOIRE !
        * pour les tests, il faut bien que je 'marque' les zones de texte trouves
        * mais en ralit il ne faut pas le faire, on obtient un curseur texte qui
        * contient la chaine trouve et sur lequel on peut faire des traitements
        This.resultats.CharBackColor = 1234567 && fond vert sombre
        RETURN .T.
      ELSE
        RETURN .F.
      ENDIF && ! ISNULL( This.resultats)
    ELSE
      RETURN .F.
    ENDIF && ! ISNULL( This.resultats)
  ENDFUNC && rechercher_suivant
  
  PROCEDURE rechercher_et_remplacer(pctexte AS String, plmotentier AS Logical, pcremplace AS String) && jme 20/10/2008
    * pctexte : texte  rechercher
    * plmotentier : .T. si mot entier
    * pcremplace : chaine de remplacement (celle qui va remplacer les occurences de pctexte
    LOCAL lltrouve, locurseur
    
    This.nombre_resultats = 0
    IF This.rechercher_premier(m.pctexte, m.plmotentier)
      lltrouve = .T.
      DO WHILE m.lltrouve
        This.resultats.string = m.pcremplace
        lltrouve = This.rechercher_suivant()
      ENDDO && m.lltrouve
    ENDIF && This.rechercher_premier(m.pctexte, m.plmotentier)
    RETURN
  ENDPROC && rechercher_et_remplacer
  
    
#IF .F.
rem Code11-04.sxw   bibli : Rechercher Module1
exemple en Visual basic oo du livre Programmation OpenOffice

Option Explicit

Sub TrouverToutPartout()
Dim monDocument As Object This.doc

Dim jeCherche As Object, trouv As Variant
Dim x As Long
monDocument = ThisComponent
jeCherche = monDocument.createSearchDescriptor
with jeCherche
  .SearchString = "Marseille"
  .SearchWords = true
end with
trouv = monDocument.findAll(jeCherche)
print "Nombre d'occurrences : " & trouv.Count
for x = 0 to trouv.Count -1
  trouv(x).CharBackColor = 1234567 ' fond vert sombre
next
End Sub


rem Code11-04.sxw   bibli : Rechercher Module2
Option Explicit

Sub TrouverToutdansleTexte()
Dim monDocument As Object, monTexte As Object
Dim jeCherche As Object, trouv As Variant
Dim x As Long, posTrouve As Object
monDocument = ThisComponent
monTexte = monDocument.Text ' objet = texte principal
jeCherche = monDocument.createSearchDescriptor
with jeCherche
  .SearchString = "Marseille"
  .SearchWords = true
end with
trouv = monDocument.findAll(jeCherche)
print "Nombre d'occurrences : " & trouv.Count
for x = 0 to trouv.Count -1
  posTrouve = trouv(x)
  if EqualUnoObjects(monTexte, posTrouve.Text) then
    ' L'occurrence est bien dans le texte principal
    posTrouve.CharBackColor = 1234567 ' fond vert sombre
  end if
next
End Sub


rem Code11-04.sxw   bibli : Rechercher Module3
Option Explicit

Sub RechercherPartoutdansleTexte()
Dim monDocument As Object, monTexte As Object
Dim jeCherche As Object, posTrouve As Object
monDocument = ThisComponent
monTexte = monDocument.Text
jeCherche = monDocument.createSearchDescriptor
with jeCherche
  .SearchString = "Marseille"
  .SearchWords = true
end with
posTrouve = monDocument.findFirst(jeCherche)
Do Until isNull(posTrouve)
  if EqualUnoObjects(monTexte, posTrouve.Text) then
    ' L'occurrence est bien dans le texte principal
    posTrouve.CharBackColor = 1234567 ' fond vert sombre
  end if
  posTrouve = monDocument.findNext(posTrouve.End, jeCherche)
Loop
End Sub

rem Code11-04.sxw   bibli : Rechercher Module4
Option Explicit

Sub RechercherDansPartieDeTexte()
Dim monDocument As Object, monTexte As Object
Dim jeCherche As Object, posTrouve As Object
Dim monCurseur  As Object
monDocument = ThisComponent
monTexte = monDocument.Text
monCurseur= monTexte.createTextCursor
monCurseur.gotoNextParagraph(false) 'dbut du 2me paragr
monCurseur.gotoNextParagraph(true) ' slection du 2me paragr
jeCherche = monDocument.createSearchDescriptor
with jeCherche
  .SearchString = "et"
  .SearchWords = true 
end with
posTrouve = monDocument.findNext(monCurseur.Start, jeCherche)
Do Until isNull(posTrouve)
  if EqualUnoObjects(monTexte, posTrouve.Text) then
    if monTexte.compareRegionEnds(_
                posTrouve, monCurseur)< 0 then Exit Do
    ' L'occurrence est dans la zone de recherche
    posTrouve.CharBackColor = 1234567 ' fond vert sombre
  end if
  posTrouve = monDocument.findNext(posTrouve.End, jeCherche)
Loop
End Sub



rem Code11-04.sxw   bibli : Rechercher Module5
Option Explicit

Sub RemplacerDansPartieDeTexte()
Dim monDocument As Object, monTexte As Object
Dim jeCherche As Object, posTrouve As Object
Dim monCurseur  As Object, Curseur2 As Object
monDocument = ThisComponent
monTexte = monDocument.Text
monCurseur= monTexte.createTextCursor
monCurseur.gotoNextParagraph(false) 'dbut du 2me paragr
monCurseur.gotoNextParagraph(true) ' slection du 2me paragr
jeCherche = monDocument.createSearchDescriptor
with jeCherche
  .SearchString = "et"
  .SearchWords = true 
end with
posTrouve = monDocument.findNext(monCurseur.Start, jeCherche)
Do Until isNull(posTrouve)
  if EqualUnoObjects(monTexte, posTrouve.Text) then
    if monTexte.compareRegionEnds(_
                posTrouve, monCurseur)< 0 then Exit Do
    ' L'occurrence est dans la zone de recherche
    Curseur2 = monTexte.createTextCursorByRange(posTrouve)
    ' Curseur2 slectionne le texte trouv
    if Curseur2.String = "Et" then Curseur2.CharHeight = 16
    Curseur2.String = "&" ' changer le texte
  end if
  posTrouve = monDocument.findNext(posTrouve.End, jeCherche)
Loop
End Sub
#ENDIF

  
ENDDEFINE && vfp_oo_writer

DEFINE CLASS oo_feuille AS Custom && jme 20/01/2008
  nom = ""                    && nom de la feuille
  pointeur = NULL             && pointeur sur une feuille oo
  *                               This.doc.getSheets().getByIndex( m.lni )
  *                  donc : comme on a un tableau dont chaque lment pointe sur une instance
  *                         de cette classe, on dispose en fait d'un pointeur sur toutes les
  *                         les feuilles oo (classes This.doc.getSheets().getByIndex( m.lni ))
  position = 0                && position de la feuille dans l'affichage
  indice = 0                  && indice de la feuille dans le tableau des feuilles
  ligne_ultime = 0            && plus grande ligne utilisable dans la feuille
  *                               normalement 65535
  colonne_ultime = 0          && plus grande colonne utilisable dans la feuille (255)
  derniere_ligne = 0          && plus grande ligne utilise
  derniere_colonne = 0        && plus grande colonne utilisee
  ligne_affichee_haut = 0     && numro de la premire ligne affiche en haut de l'cran
  *                               sert si on fait dfiler le tableau vers le bas
  colonne_affichee_gauche = 0 && numro de la premire colonne affiche  gauche de
  *                               l'cran (sert si on fait dfiler le tableau vers 
  *                               la droite)
  ligne_affichee_bas = 0      && numro de la dernire ligne affiche en bas de l'cran
  colonne_affichee_droite = 0 && numro de la dernire colonne affiche  droite de l'cran 
  coord_cellule_alpha = ""    && coordones d'une cellule au format "A5" ou "BA15"
  DIMENSION coord_cellule(2)  && 1: numro de la ligne o est la cellule (  partir de 0);
    * 2: numro de la colonne o est la cellule (  partir de 0)
  
  PROCEDURE init
    LPARAMETERS pnindice, pnpointeur
    LOCAL llresult
    
    llresult = .F.
    IF PCOUNT()>1
      IF VARTYPE(m.pnindice)=="N"
        * This.indice repre l'indice de la feuille dans le tableau 
        * vfp_oo_calc.feuilles()
        This.indice = m.pnindice
        llresult = .T.
      ENDIF && VARTYPE(m.pnindice)=="N"
      IF m.llresult AND VARTYPE( m.pnpointeur)=="O"
        This.pointeur = m.pnpointeur
      ELSE
        llresult = .F.
      ENDIF && VARTYPE( m.pnpointeur)=="O"
    ENDIF && PCOUNT()>0
    RETURN m.llresult
  ENDPROC  && init
  
  PROCEDURE destroy
  ENDPROC  && destroy
  
  PROCEDURE caracteristiques
    IF !ISNULL(This.pointeur)
      * pointeur pointe bien sur une feuille (du moins on espre !)
      WITH This
        .nom = .pointeur.name
        .position = .pointeur.getRangeAddress().Sheet
        .colonne_ultime = .pointeur.getRangeAddress().EndColumn
        .ligne_ultime = .pointeur.getRangeAddress().EndRow
        .max_ligne_colonne()
      ENDWITH  && This
    ENDIF && !ISNULL(This.pointeur)
  ENDPROC &&caracteristiques
  
  PROCEDURE max_ligne_colonne
    * calcule le plus grand numro de ligne et de colonne utilises dans la feuille
    * POUR L'INSTANT on ne mmorise pas la cellule courante pour y retourner aprs
    * le calcul. Plus tard, j'essaierai de la faire
    LOCAL locurseur
    
    WITH This
      STORE -1 TO .derniere_ligne, .derniere_colonne
      locurseur = .pointeur.createCursor()
      locurseur.GotoEndOfUsedArea( .F. )
      .derniere_ligne = locurseur.getRangeAddress.EndRow
      .derniere_colonne  = locurseur.getRangeAddress.EndColumn
    ENDWITH  && This


*!*    code fourni par Francois Gatto   ooo@volcar.org
*!*       dim oSheet as object, oCellCursor as object
*!*       dim aAbsName, nRow, nCol
*!*       oSheet = ThisComponent.CurrentController.ActiveSheet
*!*       oCellCursor = oSheet.createCursor
*!*       oCellCursor.GotoEndOfUsedArea( false )
*!*       with oCellCursor
*!*        aAbsName = .AbsoluteName
*!*           nRow     = .getRangeAddress.EndRow + 1    'because base 0
*!*           nCol     = .getRangeAddress.EndColumn + 1
*!*       end with
*!*       msgbox "Cellules utilises jusqu' l'adresse : " & chr( 10 ) & aAbsName _
*!*              & chr( 10 ) & "dernire colonne : "  & nCol _
*!*              & " - dernire ligne : " & nRow
    
  ENDPROC

#IF .F.

MACRO pour faire controle_fin : permet de connaitre le nombre de lignes
et de colonnes utilises dans une feuille

REM  *****  BASIC  *****

Sub Main
Xray ThisDocument
End Sub


sub controle_fin
rem ----------------------------------------------------------------------
rem define variables
dim document   as object
dim dispatcher as object
rem ----------------------------------------------------------------------
rem get access to the document
document   = ThisComponent.CurrentController.Frame
*    This.feuille_active = This.doc.currentController.activeSheet

dispatcher = createUnoService("com.sun.star.frame.DispatchHelper")

rem ----------------------------------------------------------------------
dim args1(1) as new com.sun.star.beans.PropertyValue
args1(0).Name = "By"
args1(0).Value = 1
args1(1).Name = "Sel"
args1(1).Value = false

dispatcher.executeDispatch(document, ".uno:GoDown", "", 0, args1())

rem ----------------------------------------------------------------------
dim args2(1) as new com.sun.star.beans.PropertyValue
args2(0).Name = "By"
args2(0).Value = 1
args2(1).Name = "Sel"
args2(1).Value = false

dispatcher.executeDispatch(document, ".uno:GoDown", "", 0, args2())

rem ----------------------------------------------------------------------
dim args3(0) as new com.sun.star.beans.PropertyValue
args3(0).Name = "Sel"
args3(0).Value = false

dispatcher.executeDispatch(document, ".uno:GoToEndOfData", "", 0, args3())


end sub

#ENDIF
  
ENDDEFINE && oo_feuille

DEFINE CLASS vfp_oo_calc AS vfp_oo && jme 07/11/2007 jme 20/01/2008
  * cette classe contient les proprits et les mthodes propres au
  * document Calc (tableur) d'openOffice
  
  nombre_feuilles = 0       && nombre de feuilles
*!*    DIMENSION feuilles(1, 3)  && tableau contenant les noms des feuilles (col 1),
*!*      * leur ordre de cration (colonne 2) et leur position (colonne 3) (les valeurs
*!*      * pour l'ordre et la position commencent  0 et non 1)
*!*      * la 2me feuille cre peut bien tre dplace  la 5me position par exemple.
  DIMENSION feuilles(1)     && tableau contenant les pointeurs sur chacune des instances
                            &&  de la classe oo_feuille corespondant  chacune des
                            && feuille du tableur  jme 20/01/2008
  feuille_active = 0        && ordre de la feuille active
  coord_cellule_alpha = ""  && coordones d'une cellule au format "A5" ou "BA15"
  DIMENSION coord_cellule(2)  && 1: numro de la ligne o est la cellule (  partir de 0);
    * 2: numro de la colonne o est la cellule (  partir de 0)
  une_cellule = NULL        && pointeur sur une structure reprsentant une cellule
  une_cellule_valeur = 0    && valeur numrique d'une cellule
  une_cellule_texte = ""    && texte contenu dans une cellule
  une_cellule_formule = ""  && formule contenue dans une cellule
  une_cellule_date = {}     && date contenue dans une cellule
  coord_region_alpha = ""   && coordonnes d'une rgion au format "A5:Z10"
  DIMENSION coord_region(4)  && 1: ligne du coin en haut  gauche, 2 colonne de ce coin;
    * 3 ligne du coin en bas  droite, 4 colonne de ce coin
  

  PROTECTED PROCEDURE init
    *  l'init on vrifie si openoffice est install
    DODEFAULT()
    IF This.erreur = 2
      * initialisation propre  Calc
      STORE 0 TO This.coord_cellule, This.coord_region
    ENDIF && This.erreur = 2
  ENDPROC && init
  
  PROTECTED PROCEDURE destroy
    IF !ISNULL(This.doc) AND This.doc.isModified AND This.abandon_document=.F.
      * si on n'a pas de nom de fichier quand on sort, on en crer un automatiquement
      IF EMPTY(This.fichier_courant)
        This.fichier_courant = "OOO_CALC_"+ SYS(2015)
      ENDIF && EMPTY(This.fichier_courant)
      This.enregistrer_document()
    ENDIF && This.doc.isModified
    This.doc = NULL
    DODEFAULT()
  ENDPROC
  
  PROCEDURE nouveau_tableur
    * on cre un nouveau document de calcul
    IF This.erreur =2
      * on ne cre pas de nouveau document s'il y en a dj un actif
      IF ISNULL(This.doc)
        This.nouveau_document( "private:factory/scalc" )
        IF ISNULL(This.doc)
          * il n'y a rien  faire ici, l'erreur a dj t donne
        ELSE
          This.maj_infos_tableur()
          This.erreur = 2 && ok
        ENDIF && ISNULL(This.doc)
      ELSE
        #IFDEF avec_ww
        WAIT WINDOW "Cration nouveau document impossible" + CHR(13)+ ;
         "un autre existe dj" NOWAIT
        #ENDIF
      ENDIF && ISNULL(This.doc)
    ENDIF && This.erreur =2
  ENDPROC
  
  PROCEDURE ouvrir_tableur( pcfichier AS String)
    * pcfichier est un nom de fichier document Calc (au format Windows)
    LOCAL ARRAY lttab(1)
    LOCAL lcurl
    
    IF EMPTY(m.pcfichier)
      This.erreur = -11 && paramtre invalide
      WAIT WINDOW "Il faut indiquer le nom du fichier  ouvrir" NOWAIT
    ELSE
      * on demande  VFP de vrifier l'existence du fichier (c'est pour faciliter
      * la gestion de l'erreur, je ne sais pas ce que fait OO si le fichier 
      * n'existe pas)
      IF ADIR(lttab, m.pcfichier) > 0
        This.erreur = 0 && on raz l'erreur ventuelle
        This.doc = NULL
        lcurl = This.OOoConvertToURL( m.pcfichier )
        This.OOoOpenURL( m.lcurl )
        IF ISNULL( This.doc)
          This.erreur = -21
          #IFDEF avec_ww
          WAIT WINDOW "Impossible d'ouvrir le fichier" + CHR(13)+ ;
           m.pcfichier NOWAIT
          #ENDIF
        ELSE
          This.maj_infos_tableur()
          This.erreur = 2 && ok
        ENDIF && ISNULL( This.doc)
      ELSE
        This.erreur = -20
        #IFDEF avec_ww
        WAIT WINDOW "Le fichier" + CHR(13)+ m.pcfichier+ CHR(13)+ ;
         "n'existe pas"NOWAIT
        #ENDIF
      ENDIF && ADIR(lttab, m.pcfichier) > 0
    ENDIF && EMPTY(pcfichier)
  ENDPROC && ouvrir_texte
  
  PROTECTED PROCEDURE maj_infos_tableur
    * met  jour les proprits nombre_feuilles, et feuilles avec
    * le nombre de feuilles leurs nom, position et ordre
    * dans This.feuilles colonne 1 : nom de la feuille, 2: indice
    *  3: position de la feuille dans la liste (l'oprateur peut
    *     dplace la (me feuille en 2me position ...)
    *  4: plus grande ligne utilise, 5: plus grande colonne utilise
    * colonne 4 et 5 en cours de test jme 20/01/2008
    * jme 20/01/2008 cration de la classe oo_feuille. Au lieu de
    *  remplir un tableau de valeurs, on va crer un tableau de pointeurs
    *  sur des instances de la classe oo_feuille et mettre  jour chacune
    *  des instances
    LOCAL lnaccu, lni, lnmax, lo1feuille, lntest

    STORE This.doc.Sheets.Count TO This.nombre_feuilles, lnaccu
*!*      DIMENSION This.feuilles(m.lnaccu,5)
*!*      lnmax = m.lnaccu -1
*!*      FOR m.lni = 0 TO m.lnmax
*!*        lnaccu = m.lni + 1
*!*        * lo1feuille = This.doc.Sheets( m.lni)
*!*        lo1feuille = This.doc.getSheets().getByIndex( m.lni )
*!*        This.feuilles( m.lnaccu, 1) = lo1feuille.Name && nom de la feuille
*!*        This.feuilles( m.lnaccu, 2) = m.lnaccu
*!*        * la troisime feuille cre a pu tre dplace  la 1re position par
*!*        * l'oprateur; la 3me colonne du tableau contient donc la position de 
*!*        * la feuille et non son ordre de cration.
*!*        This.feuilles( m.lnaccu, 3) = lo1feuille.getRangeAddress().Sheet
*!*        This.feuilles( m.lnaccu, 4) = lo1feuille.getRangeAddress().EndRow  && jme 20/01/2008
*!*        This.feuilles( m.lnaccu, 5) = lo1feuille.getRangeAddress().EndColumn
*!*      ENDFOR &&* m.lni = 0 TO m.lnmax

    DIMENSION This.feuilles(m.lnaccu)
    lnmax = m.lnaccu -1
    FOR m.lni = 0 TO m.lnmax
      lnaccu = m.lni + 1
      lo1feuille = This.doc.getSheets().getByIndex( m.lni )
      This.feuilles( m.lnaccu) = NEWOBJECT("oo_feuille", "", "", m.lnaccu, m.lo1feuille)
      This.feuilles( m.lnaccu).caracteristiques()
    ENDFOR &&* m.lni = 0 TO m.lnmax
    This.feuille_active = This.doc.currentController.activeSheet
  ENDPROC && maj_infos_tableur

  PROCEDURE enregistrer_copie_document( pcnomfichier AS String)  && vfp_oo_calc
    * on veut crer une copie du tableur courant (on cre un fichier
    * sur le disque mais on continue de travailler sur le document courant)
    * pcnomfichier contient un nom de fichier (avec ventuellement un chemin)
    * au format Windows
    * on va crer systmatiquement un export PDF
    IF PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
      IF EMPTY( JUSTPATH(m.pcnomfichier))
        * on ne peut pas sauvegarder un document SANS lui donner le chemin complet !
        pcnomfichier = SYS(5)+ CURDIR()+ m.pcnomfichier
      ENDIF && EMPTY( JUSTPATH(m.pcnomfichier))
      DODEFAULT( m.pcnomfichier)
      LOCAL lcurl
      LOCAL ARRAY lcparam(2)
      * on veut prvenir l'oprateur s'il crase une version prcdente du document
      * (mme si c'est le mme fichier; si c'est trop perturbant on peut supprimer
      *  cette option ou supprimer le PDF avant de lancer cette mthode)
      lcparam(2) = This.OOoPropertyValue( "Overwrite", .T. )
      lcparam(1) = This.OOoPropertyValue( "FilterName", "calc_pdf_Export")
      * il faut enlever l'ventuelle extension du nom du fichier pour la remplacer par .pdf
      lcurl = This.OOoConvertToURL( JUSTPATH(m.pcnomfichier)+ "\"+ JUSTSTEM(m.pcnomfichier)+ ".pdf")
      This.doc.storeToURL( m.lcurl, @ lcparam)
    ENDIF && PCOUNT() = 1 AND ! EMPTY(m.pcnomfichier)
  ENDPROC && enregistrer_document
  
  PROCEDURE informations_document
    LOCAL lcfichier, loinfos, lodate
    IF !ISNULL(This.doc)
      lcfichier = This.doc.location
      loinfos = This.doc.documentInfo
      lodate = loinfos.CreationDate
      = MESSAGEBOX("document :"+ m.lcfichier+ CHR(13)+ ;
       "auteur: "+ m.loinfos.Author+ CHR(13)+ ;
       "cration: "+ STR(m.lodate.Day,2)+"/"+ TRANSFORM(m.lodate.Month, "@L 99")+ ;
        "/"+ STR(m.lodate.Year,4)+ CHR(13)+ ;
       "nombre de feuilles: "+ ALLTRIM(STR(This.nombre_feuilles,6)), 0, "informations")
    ENDIF && !ISNULL(This.doc)
  ENDPROC && informations_document

  PROCEDURE selection_feuille(luparametre)
    * si luparametre est une chane de caractres, on recherche la feuille qui porte
    * ce nom. Si c'est une valeur numrique, on cherche la feuille de ce rang (ordre
    * visible commenant  1 et non ordre de cration)
    *  oSheet = oDoc.getSheets().getByIndex( 0 ) ' get the zero'th sheet
    *  oSheet = oDoc.getSheets().getByName( "Sheet3" ) ' get by name

    IF PCOUNT() > 0
      IF VARTYPE(m.luparametre)=="C" AND !EMPTY(m.luparametre)
        * on cherche le feuille qui porte le nom pass en paramtre
        IF This.doc.getSheets().hasByName( m.luparametre)
          This.feuille_active = NULL
          This.feuille_active = This.doc.getSheets().getByName( m.luparametre )
          IF ISNULL(This.feuille_active)
            #IFDEF avec_ww
            WAIT WINDOW "La feuille" + CHR(13)+ m.luparametre+ CHR(13)+ ;
             "est impossible  atteindre" NOWAIT
            #ENDIF
          ELSE
            This.doc.currentController.activeSheet = This.feuille_active
          ENDIF && ISNULL(This.feuille_active)
        ELSE
          #IFDEF avec_ww
          WAIT WINDOW "La feuille" + CHR(13)+ m.luparametre+ CHR(13)+ ;
           "n'existe pas" NOWAIT
          #ENDIF
        ENDIF && This.doc.getSheets().hasByName( "Sheet3" )
      ELSE
        IF VARTYPE(m.luparametre)=="N" OR VARTYPE(m.luparametre)=="I"
          IF BETWEEN(m.luparametre, 1, This.nombre_feuilles)
            This.feuille_active = NULL
            This.feuille_active = This.doc.getSheets().getByIndex( m.luparametre -1)
            IF ISNULL(This.feuille_active)
              #IFDEF avec_ww
              WAIT WINDOW "La feuille n " + STR(m.luparametre)+ CHR(13)+ ;
               "est impossible  atteindre" NOWAIT
              #ENDIF
            ELSE
              This.doc.currentController.activeSheet = This.feuille_active
            ENDIF && ISNULL(This.feuille_active)
          ELSE
            #IFDEF avec_ww
            WAIT WINDOW "numro de feuille hors limites" NOWAIT
            #ENDIF
          ENDIF && BETWEEN(m.luparametre, 1, This.nombre_feuilles)
        ELSE
          #IFDEF avec_ww
          WAIT WINDOW "paramtre incorrect" NOWAIT
          #ENDIF
        ENDIF && VARTYPE(m.luparametre)=="N"
      ENDIF && VARTYPE(m.luparametre)=="C"
    ELSE
      #IFDEF avec_ww
      WAIT WINDOW "Il me faut le nom de la feuille" + CHR(13)+ ;
       "ou son numro d'ordre" NOWAIT
      #ENDIF
    ENDIF && PCOUNT() > 0
  ENDPROC && selection_feuille
  
  PROCEDURE ajouter_feuille( lnposition AS Number, lcnom AS String)
    * On ajoute la feuille de nom lcnom  la position lnposition.
    * lnposition compris entre 1 (et non 0) et This.nombre_feuilles + 1
    * NOTE : je met beaucoup de tests mais c'est pour faciliter le dboguage
    IF PCOUNT()=2 AND BETWEEN(m.lnposition, 1, This.nombre_feuilles+1) AND ;
     !EMPTY(m.lcnom)
      IF This.doc.getSheets().hasByName( m.lcnom)
        * une feuille porte dj ce nom
        #IFDEF avec_ww
        WAIT WINDOW "Une feuille porte dj le nom" + CHR(13)+ m.lcnom NOWAIT
        #ENDIF
      ELSE
        LOCAL lofeuille, llresult, lnaccu
        llresult = .F.
        * on mmorise qu'elle est la feuille active pour y revenir si l'ajout
        * de la nouvelle feuille ne fonctionne pas
        lofeuille = This.feuille_active
        This.feuille_active = NULL
        This.doc.getSheets().insertNewByName(m.lcnom, m.lnposition-1)
        IF This.doc.getSheets().hasByName( m.lcnom)
          This.feuille_active = This.doc.getSheets().getByName( m.lcnom)
          IF ISNULL( This.feuille_active)
            This.feuille_active = m.lofeuille
          ELSE
            llresult = .T. && jme 20/01/2008
          ENDIF && ISNULL( This.feuille_active)
        ELSE
          This.feuille_active = m.lofeuille
        ENDIF && This.doc.getSheets().hasByName( m.lcnom)
        This.doc.currentController.activeSheet = This.feuille_active
        IF m.llresult
          * on a bien ajout la nouvelle feuille, il faut mettre  jour les
          * lments du tableur
          lnaccu = This.nombre_feuilles + 1
          This.nombre_feuilles = m.lnaccu
          DIMENSION This.feuilles (m.lnaccu)
          This.feuilles( m.lnaccu) = ;
            NEWOBJECT("oo_feuille", "", "", m.lnaccu, This.feuille_active)
          This.feuilles( m.lnaccu).caracteristiques()
        ENDIF && m.llresult
      ENDIF && This.doc.getSheets().hasByName( m.lcnom)
    ELSE
      #IFDEF avec_ww
      WAIT WINDOW "Au moins un paramtre incorrect" NOWAIT
      #ENDIF
    ENDIF && PCOUNT()=2 AND BETWEEN(m.lnposition, 1, This.nombre_feuilles+1) AND
  ENDPROC && ajouter_feuille
  
*!*    coord_cellule_alpha = ""  && coordones d'une cellule au format "A5" ou "BA15"
*!*    DIMENSION coord_cellule(2)  && 1: numro de la ligne o est la cellule (  partir de 0);
*!*      * 2: numro de la colonne o est la cellule (  partir de 0)
  
  PROCEDURE cellule_coord_alpha_vers_num( m.lccoord AS String)
    * dans OO.Calc, une cellule peut tre accde par deux types de coordonnes quivalentes :
    * le texte "A1" ou "AA5" ou par ses numros de ligne/ numros de colonne.
    * "A1" quivaut  0,0
    IF PCOUNT()=1 AND !EMPTY(m.lccoord)
      This.coord_cellule_alpha = ALLTRIM(m.lccoord)
    ENDIF && PCOUNT()=1 AND !EMPTY(m.lccoord)
    LOCAL lnligne, lnaccu, lncolonne, lccar, lnlong
    STORE 0 TO lncolonne, lnligne
    lnaccu = 1
    lnlong = LEN(This.coord_cellule_alpha)
    lccar = LEFT(This.coord_cellule_alpha,1)
    DO WHILE ISALPHA(m.lccar)
      lncolonne = m.lncolonne * 26 + (ASC(m.lccar)-64)
      lnaccu = m.lnaccu + 1
      lccar = IIF(m.lnaccu<=m.lnlong, SUBSTR( This.coord_cellule_alpha, m.lnaccu,1), "")
    ENDDO && ISALPHA(SUBSTR( This.coord_cellule_alpha, m.lnaccu,1))
    * normalement, lccar contient le premier chiffre
    DO WHILE ISDIGIT(m.lccar)
      lnligne = m.lnligne * 10 + (ASC(m.lccar)-48)
      lnaccu = m.lnaccu + 1
      lccar = IIF(m.lnaccu<=m.lnlong, SUBSTR( This.coord_cellule_alpha, m.lnaccu,1), "")
    ENDDO && ISALPHA(SUBSTR( This.coord_cellule_alpha, m.lnaccu,1))
    This.coord_cellule(1)= m.lnligne - 1
    This.coord_cellule(2)= m.lncolonne - 1
  ENDPROC && cellule_coord_alpha_vers_num
  
  PROCEDURE cellule_coord_num_vers_alpha( lnligne AS Number, lncol AS Number)
    * lnligne et lncol commence  0 (et non 1)
    * dans OO.Calc, une cellule peut tre accde par deux types de coordonnes quivalentes :
    * le texte "A1" ou "AA5" ou par ses numros de ligne/ numros de colonne.
    * "A1" quivaut  0,0
    IF PCOUNT()=2
      This.coord_cellule(1)= m.lnligne
      This.coord_cellule(2)= m.lncol
    ENDIF && PCOUNT()=2
    LOCAL lnli, lnco, lnaccu, lcresult
    lcresult = ""
    lnco = This.coord_cellule(2)
    DO CASE
    CASE m.lnco >= 702
      * le rsultat a 3 lettres
      lnaccu = INT(m.lnco / 702)
      lcresult = m.lcresult + CHR(64+ m.lnaccu)
      lnco = m.lnco - m.lnaccu*702
      lnaccu = INT(m.lnco / 26)
      lcresult = m.lcresult + CHR(65+ m.lnaccu)
      lnco = m.lnco - m.lnaccu*26
      lcresult = m.lcresult + CHR(65+m.lnco)
    CASE m.lnco >= 26
      lnaccu = INT(m.lnco / 26)
      lcresult = m.lcresult + CHR(64+ m.lnaccu)
      lnco = m.lnco - m.lnaccu*26
      lcresult = m.lcresult + CHR(65+m.lnco)
    CASE m.lnco >= 0
      lcresult = m.lcresult + CHR(65+m.lnco)
    ENDCASE
    * maintenant que l'on a les lettres, on fait les chiffres, c'est plus simple
    This.coord_cellule_alpha = m.lcresult+ ALLTRIM(STR(This.coord_cellule(1)+1,6))
  ENDPROC && cellule_coord_num_vers_alpha
  
  PROCEDURE texte_dans_cellule( pctext AS String, pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    This.une_cellule_texte = m.pctext
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    *This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1)).setString( m.pctext )
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setString( m.pctext )
  ENDPROC && texte_dans_cellule
  
  PROCEDURE valeur_dans_cellule( pnvaleur AS Number, pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    This.une_cellule_valeur = m.pnvaleur
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    *This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1)).setValue( m.pnvaleur )
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setValue( m.pnvaleur )
  ENDPROC && valeur_dans_cellule
  
  PROCEDURE formule_dans_cellule( pctext AS String, pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    This.une_cellule_formule = m.pctext
    *This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1)).setFormula( m.pctext )
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setFormula( m.pctext )
  ENDPROC && texte_dans_cellule
  
  PROCEDURE date_dans_cellule( pudate,  pnligne AS Number, pncol AS Number)
    * si on ne transmet qu'un seul paramtre, on travaille sur la cellule courante
    IF PCOUNT()=3
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
    ENDIF && PCOUNT()=3
    * attention, dans getCellPosition le 1ere paramtre est la colonne, le 2me la ligne
    LOCAL lddate, lcaccu, loformat, lolocal, lnformatdate
    lcaccu = VARTYPE(m.pudate)
    IF m.lcaccu=="T"
      lddate = TTOD(m.pudate)
    ELSE
      IF m.lcaccu=="D"
        lddate = m.pudate
      ELSE
        lddate = DATE()
      ENDIF && m.lcaccu=="D"
    ENDIF && VARTYPE(m.pudate)=="T"
    This.une_cellule_date = m.lddate
    * on dtaille les calculs pour faciliter le set step on
    * DTOC ne convient pas car OO veut une date  l'amricaine ...
    *lcaccu = DTOC(m.lddate)
    lcaccu = TRANSFORM( MONTH(m.lddate), "@L 99")+"/"+ ;
     TRANSFORM( DAY(m.lddate), "@L 99")+"/"+ STR(YEAR(m.lddate),4)
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule.setFormula( m.lcaccu)
    * dans les quelques lignes ci-dessous, je recopie btement l'exemple; j'ai pas tout compris.
    loformat = This.doc.getNumberFormats()
    lolocal = This.OOoCreateStruct( "com.sun.star.lang.Locale" )
    * com.sun.star.util.NumberFormat.DATE = 2
    lnformatdate = loformat.getStandardFormat( 2, lolocal) && 2 = date
    This.une_cellule.NumberFormat = m.lnformatdate
  ENDPROC && date_dans_cellule
  
  PROCEDURE lire_une_cellule( pnligne AS Number, pncol AS Number)
    * lit le contenu d'une cellule
    * pnligne et pncol commence  0 (et non 1) ATTENTION, on met d'abord la
    *  ligne puis la colonne
    * si on ne transmet pas de paramtre, on travaille sur la cellule courante;
    *  cette cellule peut tre slectionne par la mthode 
    *  cellule_coord_alpha_vers_num("A3") de cette classe
    
    * mais comment savoir le type de donne ? les 3 composantes d'une cellule 
    *  (texte, valeur et formule) peuvent contenir quelquechose EN MEME TEMPS !
    *  par exemple formule contiendra le texte de la formule, valeur la valeur
    *  numrique correspondante et texte le texte affich (la transformation de
    *  valeur selon le format spcifi pour l'affichage).
    * si c'est une valeur numrique, string et formula contiennent le STR(valeur)!
    IF PCOUNT()=2
      This.coord_cellule(1)= m.pnligne
      This.coord_cellule(2)= m.pncol
*      This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    ENDIF && PCOUNT()=3
    This.une_cellule = This.feuille_active.getCellByPosition( This.coord_cellule(2), This.coord_cellule(1))
    This.une_cellule_valeur = This.une_cellule.value && valeur numrique de la cellule
    This.une_cellule_texte = This.une_cellule.string && texte contenu dans la cellule
    This.une_cellule_formule = This.une_cellule.formula && formule contenue dans la cellule
*!*    une_cellule_date = {}     && date contenue dans une cellule
    LOCAL lnaccu
    lnaccu = 0 && pour le set step on
  ENDPROC && lire_une_cellule
  
  
ENDDEFINE && vfp_oo_calc



* ATTENTION : NE METTRE AUCUN CODE EXECUTABLE APRES UN DEFINE CLASS


#IF .F.
contenu de l'example VFP trouv dans http://www.oooforum.org/forum/viewtopic.phtml?p=28389#28389

VfpOOoCalcExample()

PROCEDURE VfpOOoCalcExample()
   * Create a spreadsheet.
   LOCAL oDoc
   oDoc = OOoOpenURL( "private:factory/scalc" )
   
   * Get first sheet
   LOCAL oSheet
   oSheet = oDoc.getSheets().getByIndex( 0 )
   
   *-----
   * Put some sales figures onto the sheet.
   oSheet.getCellByPosition( 0, 0 ).setString( "Month" )
   oSheet.getCellByPosition( 1, 0 ).setString( "Sales" )
   oSheet.getCellByPosition( 2, 0 ).setString( "End Date" )
   
   oSheet.getCellByPosition( 0, 1 ).setString( "Jan" )
   oSheet.getCellByPosition( 0, 2 ).setString( "Feb" )
   oSheet.getCellByPosition( 0, 3 ).setString( "Mar" )
   oSheet.getCellByPosition( 0, 4 ).setString( "Apr" )
   oSheet.getCellByPosition( 0, 5 ).setString( "May" )
   oSheet.getCellByPosition( 0, 6 ).setString( "Jun" )
   oSheet.getCellByPosition( 0, 7 ).setString( "Jul" )
   oSheet.getCellByPosition( 0, 8 ).setString( "Aug" )
   oSheet.getCellByPosition( 0, 9 ).setString( "Sep" )
   oSheet.getCellByPosition( 0, 10 ).setString( "Oct" )
   oSheet.getCellByPosition( 0, 11 ).setString( "Nov" )
   oSheet.getCellByPosition( 0, 12 ).setString( "Dec" )
   
   oSheet.getCellByPosition( 1, 1 ).setValue( 3826.37 )
   oSheet.getCellByPosition( 1, 2 ).setValue( 3504.21 )
   oSheet.getCellByPosition( 1, 3 ).setValue( 2961.45 )
   oSheet.getCellByPosition( 1, 4 ).setValue( 2504.12 )
   oSheet.getCellByPosition( 1, 5 ).setValue( 2713.98 )
   oSheet.getCellByPosition( 1, 6 ).setValue( 2448.17 )
   oSheet.getCellByPosition( 1, 7 ).setValue( 1802.13 )
   oSheet.getCellByPosition( 1, 8 ).setValue( 2203.22 )
   oSheet.getCellByPosition( 1, 9 ).setValue( 1502.54 )
   oSheet.getCellByPosition( 1, 10 ).setValue( 1207.68 )
   oSheet.getCellByPosition( 1, 11 ).setValue( 1819.71 )
   oSheet.getCellByPosition( 1, 12 ).setValue( 986.03 )
   
   oSheet.getCellByPosition( 2, 1 ).setFormula( "=DATE(2004;01;31)" )
   oSheet.getCellByPosition( 2, 2 ).setFormula( "=DATE(2004;02;29)" )
   oSheet.getCellByPosition( 2, 3 ).setFormula( "=DATE(2004;03;31)" )
   oSheet.getCellByPosition( 2, 4 ).setFormula( "=DATE(2004;04;30)" )
   oSheet.getCellByPosition( 2, 5 ).setFormula( "=DATE(2004;05;31)" )
   oSheet.getCellByPosition( 2, 6 ).setFormula( "=DATE(2004;06;30)" )
   oSheet.getCellByPosition( 2, 7 ).setFormula( "=DATE(2004;07;31)" )
   oSheet.getCellByPosition( 2, 8 ).setFormula( "=DATE(2004;08;31)" )
   oSheet.getCellByPosition( 2, 9 ).setFormula( "=DATE(2004;09;30)" )
   * Note that these last three dates are not set as DATE() function calls.
   oSheet.getCellByPosition( 2, 10 ).setFormula( "10/31/2004" )
   oSheet.getCellByPosition( 2, 11 ).setFormula( "11/30/2004" )
   oSheet.getCellRangeByName( "C13" ).setFormula( "12/31/2004" )
   *-----
   
   * Format the date cells as dates.   
   oFormats = oDoc.getNumberFormats()
   oLocale = OOoCreateStruct( "com.sun.star.lang.Locale" )
   * com.sun.star.util.NumberFormat.DATE = 2
   nDateKey = oFormats.getStandardFormat( 2, oLocale )
   oCell = oSheet.getCellRangeByName( "C2:C13" )
   oCell.NumberFormat = nDateKey
   
   LOCAL ARRAY aOneArg[1]
   LOCAL cFile, cURL
   
*   cFile = GetDesktopFolderPathname()+"example"
   cFile = "c:\example"

   * Now save the spreadsheet.
   cURL = OOoConvertToURL( cFile + ".sxw" )
   aOneArg[1] = OOoMakePropertyValue( "Overwrite", .T. )
   oDoc.storeToUrl( cURL, @ aOneArg )
   
   * Now save it as Excel
   cURL = OOoConvertToURL( cFile + ".xls" )
   aOneArg[1] = OOoMakePropertyValue( "FilterName", "MS Excel 97" )
   oDoc.storeToUrl( cURL, @ aOneArg )
   
   * Close the document.
*   oDoc.close( 1 ) && TRUE
ENDPROC





* Open or Create a document from it's URL.
* New documents are created by URL's such as:
*   private:factory/sdraw
*   private:factory/swriter
*   private:factory/scalc
*   private:factory/simpress
FUNCTION OOoOpenURL( cURL )
*   LOCAL oPropertyValue
*   oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )

*   LOCAL ARRAY aNoArgs[1]
*   aNoArgs[1] = oPropertyValue
*   aNoArgs[1].Name = "ReadOnly"
*   aNoArgs[1].Value = .F.

   * These two lines replace the alternate version above,
   *  which are left commented for the insight they provide.
   LOCAL ARRAY aNoArgs[1]
   aNoArgs[1] = OOoMakePropertyValue( "Hidden", .F. )
   
   LOCAL oDesktop
   oDesktop = OOoGetDesktop()

   LOCAL oDoc
   oDoc = oDesktop.LoadComponentFromUrl( cURL, "_blank", 0, @ aNoargs )
   
   * Make sure that arrays passed to this document are passed zero based.
   COMARRAY( oDoc, 10 )
   
   RETURN oDoc
ENDFUNC

* Create a com.sun.star.beans.PropertyValue struct and return it.
FUNCTION OOoMakePropertyValue( cName, uValue, nHandle, nState )
   LOCAL oPropertyValue
   oPropertyValue = OOoCreateStruct( "com.sun.star.beans.PropertyValue" )
   
   oPropertyValue.Name = cName
   oPropertyValue.Value = uValue
   
   IF TYPE([nHandle])="N"
      oPropertyValue.Handle = nHandle
   ENDIF
   IF TYPE([nState])="N"
      oPropertyValue.State = nState
   ENDIF
   
   RETURN oPropertyValue
ENDFUNC



* Sugar coated routine to create any UNO struct.
* Use the Bridge_GetStruct() feature of the OLE-UNO bridge.
FUNCTION OOoCreateStruct( cTypeName )
   LOCAL oServiceManager
   oServiceManager = OOoGetServiceManager()
   
   LOCAL oStruct
   oStruct = .NULL.

   LOCAL cOldErrHandler
   cOldErrHandler = ON( "ERROR" )
   ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
      oStruct = oServiceManager.Bridge_GetStruct( cTypeName )
   ON ERROR &cOldErrHandler
   
   IF ISNULL( oStruct )
      =__OOoReleaseCachedVars()
      oServiceManager = OOoGetServiceManager()
      oStruct = oServiceManager.Bridge_GetStruct( cTypeName )
   ENDIF

   RETURN oStruct
ENDFUNC


* Return the OpenOffice.org desktop object.
* Cache it in a global variable.
* Create it if not already cached.
FUNCTION OOoGetDesktop()
   IF (TYPE([goOOoDesktop])!="O")  OR  ISNULL( goOOoDesktop )
      PUBLIC goOOoDesktop
      goOOoDesktop = OOoServiceManager_CreateInstance( "com.sun.star.frame.Desktop" )
      COMARRAY( goOOoDesktop, 10 )
   ENDIF
   RETURN goOOoDesktop
ENDFUNC



* Return the OpenOffice.org service manager object.
* Cache it in a global variable.
* Create it if not already cached.
FUNCTION OOoGetServiceManager()
   IF (TYPE([goOOoServiceManager])!="O")  OR  ISNULL( goOOoServiceManager )
      PUBLIC goOOoServiceManager
      goOOoServiceManager = CREATEOBJECT( "com.sun.star.ServiceManager" )
   ENDIF
   RETURN goOOoServiceManager
ENDFUNC


* Sugar coated routine to ask the service manager to
*  create you an instance of some other OpenOffice.org UNO object.
FUNCTION OOoServiceManager_CreateInstance( cServiceName )
   LOCAL oServiceManager
   oServiceManager = OOoGetServiceManager()
   
   LOCAL oInstance
   oInstance = .NULL.

   LOCAL cOldErrHandler
   cOldErrHandler = ON( "ERROR" )
   ON ERROR = DoNothing__ErrorHandler( ERROR(), MESSAGE(), LINENO(), SYS(16), PROGRAM(), SYS(2018) )
      oInstance = oServiceManager.createInstance( cServiceName )
   ON ERROR &cOldErrHandler
   
   IF ISNULL( oInstance )
      =__OOoReleaseCachedVars()
      oServiceManager = OOoGetServiceManager()
      oInstance = oServiceManager.createInstance( cServiceName )
   ENDIF

   RETURN oInstance
ENDFUNC


PROCEDURE DoNothing__ErrorHandler( pnError, pcErrMessage, pnLineNo, pcProgramFileSys16, pcProgram, pcErrorParamSys2018 )
ENDPROC


PROCEDURE __OOoReleaseCachedVars()
   RELEASE goOOoServiceManager, goOOoDesktop, goOOoCoreReflection
ENDPROC


* Convert a local filename to an OOo URL.
FUNCTION OOoConvertToURL( cFilename )
   * Ensure leading slash.
   IF LEFT( cFilename, 1 ) != "/"
      cFileName = "/" + cFileName
   ENDIF
   
   LOCAL cURL
   cURL = CHRTRAN( cFilename, "\", "/" )   && change backslashes to forward slashes.
   cURL = "file://" + cURL
   RETURN cURL
ENDFUNC



MACRO pour faire controle_fin : permet de connaitre le nombre de lignes
et de colonnes utilises dans une feuille

REM  *****  BASIC  *****

Sub Main
Xray ThisDocument
End Sub


sub controle_fin
rem ----------------------------------------------------------------------
rem define variables
dim document   as object
dim dispatcher as object
rem ----------------------------------------------------------------------
rem get access to the document
document   = ThisComponent.CurrentController.Frame
dispatcher = createUnoService("com.sun.star.frame.DispatchHelper")

rem ----------------------------------------------------------------------
dim args1(1) as new com.sun.star.beans.PropertyValue
args1(0).Name = "By"
args1(0).Value = 1
args1(1).Name = "Sel"
args1(1).Value = false

dispatcher.executeDispatch(document, ".uno:GoDown", "", 0, args1())

rem ----------------------------------------------------------------------
dim args2(1) as new com.sun.star.beans.PropertyValue
args2(0).Name = "By"
args2(0).Value = 1
args2(1).Name = "Sel"
args2(1).Value = false

dispatcher.executeDispatch(document, ".uno:GoDown", "", 0, args2())

rem ----------------------------------------------------------------------
dim args3(0) as new com.sun.star.beans.PropertyValue
args3(0).Name = "Sel"
args3(0).Value = false

dispatcher.executeDispatch(document, ".uno:GoToEndOfData", "", 0, args3())


end sub

#ENDIF